<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;

class AppProjectController extends Controller
{
    public function get_app_projects(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);


        $stmt = $this->pdo->prepare("Select Project_Name,
                           License_Link
                           From App_Project_Licenses
                           where Used_Flag='Y'
                           Order By  Project_Name");
        $stmt->execute();
        //$stmt->execute([$fsono]);
        $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);

        if(!empty($arr)) {
            foreach($arr as $key=>$details){
                $data[$key]['Project_Name'] = $details['Project_Name'];
                $data[$key]['License_Link'] = $details['License_Link'];
            }

            $msg = 'Success';
        } else {
            $msg = 'No Open Source Projects Used';
            $status = false;
        }

        return  get_response($msg, $status, $data);
    }
}
