<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use DB;

class AreaController extends Controller
{
    //get all area

    public function get_all_area(Request $request){

        $City_Code = $request->has('City_Code') ? $request->input('City_Code') : NULL;
        try {
            if (isset($City_Code)) {
                // if json input have city code parameter then all area of given city
                $data = DB::select("select Area_Code as code, Area_Name as name , Pincode , COALESCE(Latitude,0) as Latitude , COALESCE(Longitude,0) as Longitude from Area_Master where Status = 'A' and City_Code='$City_Code' order by Area_Name");
            } else {
                // if json input don't have city code parameter then all area get selected
                $data = DB::select("select Area_Code code , Area_Name name , Pincode , COALESCE(Latitude,0) as Latitude , COALESCE(Longitude,0) as Longitude  from   Area_Master where Status = 'A' order by Area_Name");
            }
            if (!empty($data)) {
                $msg = 'Success';
                $status = true;
            } else {
                $msg = 'Area Data is not available';
                $status = false;
            }
        } catch (\Exception $e) {
            $msg = "Something went wrong";
            $data = $e->getMessage();
            $status = false;
        }

        return get_response($msg, $status, $data);
    }
}
