<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;
use PDOException;

class CategoriesController extends Controller
{
    public function get_all_categories_for_level(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);
        //header_remove("Cache-Control");

        try{
            $business_id    = $Business_ID;
            $parent_cat     = $Parent_Cat;
            $StoreNo        = $Store_No;
            $BrandNo        = 'null';
            if (isset($Brand_No)) {
                $BrandNo        = $Brand_No ? $Brand_No : 'null';
            }
            $FSONo          = $FSO_No ? $FSO_No :'';
            $CustNo         = $Cust_No? $Cust_No :'';
            $CityCode       = $City_Code? $City_Code:'6'; //CITY_BASED_CATALOG,Default Pune city code for AD
            $wherebrand ='';
            $wherecat   ='';

            $wherecatlevel='';
            $catcollevel='';
            $getlevelsql=$this->pdo->prepare("Select Find_Level($parent_cat) as lvl");
            $getlevelsql->execute();
            $result = $getlevelsql->fetch(PDO::FETCH_ASSOC);

            if (!empty($result)){
                $row = $result;
                $level=$row['lvl'];
                $wherecatlevel = 'AND Level_'.$level.' = '.$parent_cat.' ';
                $nextlevel=$level+1;
                $catcollevel   = 'Level_'.$nextlevel;
            }
            else{
                $wherecatlevel = 'AND Level_0 ';
                $catcollevel   = 'Level_1';
            }
            $getCustType = getCustType($this->pdo, $CustNo, $StoreNo);
            dd($getCustType);
            $allCategories = array();
            if((!empty($FSONo)) && ($FSONo > 0)){ //if FSO given

                if ($nextlevel ==1) {
                    $sql = $this->pdo->prepare("select DISTINCT Filter_ID as cat ,Filter_Type as type
                from   BBC_Org_User_Filters
                where  Store_No = '$StoreNo'
                and    FSO_No   = '$FSONo'
                and    Status   ='A'");
                    $sql -> execute();
                    $result = $sql->fetchAll(PDO::FETCH_ASSOC);
                    //FSO mapped to Categories
                    if (!empty($result)){
                        //loop thru all the categories and find if 0-ALL category mapped
                        $mappedCat=array();
                        $mappedBrands=array();
                        $allCatFlag=0;$allBrandFlag=0;
                        foreach($result as $row1)
                        {

                            if ($row1['type'] =="Category") {   //Categories
                                if ($row1['cat']=='0')
                                    $allCatFlag=1;
                                else
                                    array_push($mappedCat,$row1['cat']);
                            }
                            else {  //Brands
                                if ($row1['cat'] =='0')
                                    $allBrandFlag=1;
                                else
                                    array_push($mappedBrands,$row1['cat']);
                            }
                        }
                        $commaSepCat   = implode(",",$mappedCat);
                        $commaSepBrands= implode(",",$mappedBrands);
                        if ($allCatFlag ==1){
                            if($allBrandFlag==1) {
                                //return all Categories   &  all  Brands
                                $wherebrand='';
                                $wherecat  ='';

                            }
                            else {  //All Categories selected Brands
                                $wherebrand=$wherebrand.' AND    A.Brand_ID IN('.$commaSepBrands.') ';
                                $wherecat='';
                            }
                        }
                        else {
                            if ($allBrandFlag ==1) {
                                //return mapped category && all Brands
                                $wherecat = $wherecat.' AND   node.Category_ID IN('.$commaSepCat.') ';
                                $wherebrand ='';
                            }
                            else { //mapped categories and mapped Brands

                                $wherecat = $wherecat.' AND   node.Category_ID IN('.$commaSepCat.') ';
                                $wherebrand=$wherebrand.' AND    A.Brand_ID IN('.$commaSepBrands.') ';

                            }
                        }


                    }

                    else{ //FSO not mapped to Category

                        //no Categories should be returned
                    }

                }
                else{ //if not first level
                    $sql = $this->pdo->prepare("select DISTINCT Filter_ID as cat ,Filter_Type as type
                from   BBC_Org_User_Filters
                where  Store_No = '$StoreNo'
                and    FSO_No   = '$FSONo'
                and    Filter_Type ='Brand'
                and    Status   ='A'");
                    $sql->execute();
                    $result = $sql->fetchAll(PDO::FETCH_ASSOC);
                    if (!empty($result)){
                        $mappedBrands=array();
                        $allBrandFlag=0;
                        foreach($result as $row1)
                        {

                            //Brands
                            if ($row1['cat'] =='0')
                                $allBrandFlag=1;
                            else
                                array_push($mappedBrands,$row1['cat']);

                        }

                        $commaSepBrands= implode(",",$mappedBrands);
                        if ($allBrandFlag ==1) {
                            $wherebrand='';
                            $wherecat='';

                        }
                        else{  //Mapped Brands
                            $wherebrand=$wherebrand.' AND    A.Brand_ID IN('.$commaSepBrands.') ';
                            $wherecat='';
                        }

                    }
                    else {
                        //no brands found
                    }
                }
            }
            else {  //if FSO not given

                // $wherecat ='';
                // $wherebrand='';
                // $result = mysqli_query($con,$sql);
                // while($row = mysqli_fetch_array($result,MYSQLI_ASSOC))
                // {
                //         array_push($allCategories,$row);
                // }
            }

            $mainsql = $this->pdo->prepare("SELECT  node.Category_ID as cat,
                node.Cat_Desc as 'desc',
                node.Image_Url as Image_Url,
                0 AS depth,
                Is_Leaf(node.Category_ID) as Is_Leaf_Node,
                node.lft AS 'left_node',
                node.rgt AS 'right_node'
                FROM Nested_Category AS node
                WHERE node.Business_ID   ='$business_id'
                AND   node.Category_ID in (SELECT distinct $catcollevel
                                            from Article_Master A
                                            INNER JOIN Store_Listing S on S.Article_No= A.Article_No
                                            INNER JOIN Store_Cust_Article_Price SCAP ON SCAP.Article_No = A.Article_No and SCAP.Store_No = S.Store_No
                                            INNER JOIN Article_Category C  on C.Article_No = A.Article_No AND S.Article_No=C.Article_No
                                            LEFT OUTER JOIN Store_City_Article SC on SC.Store_No = S.Store_No AND S.Article_No = SC.Article_No and SC.City_Code = '$CityCode'
                                            WHERE S.Store_No='$StoreNo'
                                            AND SCAP.Cust_Type = '$getCustType'
                                            AND SCAP.Offer_Price>0
                                            AND    C.Business_ID = '$business_id'
                                            AND    C.Status='A'
                                            and    ifnull(SC.Show_Flag,1)>0
                                            AND    A.Status  ='A'
                                            AND    S.Status  ='A'
                                            AND    A.Brand_ID=IFNULL($BrandNo,A.Brand_ID)  $wherebrand
                                            $wherecatlevel
                                            )
                $wherecat
                ORDER BY node.lft");

            $mainsql->execute();
            $result = $mainsql->fetchAll(PDO::FETCH_ASSOC);
            foreach($result as $row)
            {
                array_push($allCategories,$row);
            }
            if(!empty($allCategories))
            {
                $msg= 'Success';
                $data = $allCategories;
            }
            else
            {
                $msg="fail";
                $status = false;
                $data = $allCategories;
            }
        }
        catch (PDOException $e)
        {
            $status = false;
            $data = $e->getMessage();
            $msg = "Something went wrong";
        }
        return get_response( $msg, $status, $data);
    }

    public function getAllCategory(Request $request){
        $post = $request->post();
        extract($post);

        $data = array();
        $status = true;
        try{
            if(empty($businessId)){
                $msg = "Please provide a Business ID";
                $status = false;
            } else {

                $query = "SELECT `Category_ID`,`Status` FROM `Nested_Category` WHERE Status='A' and business_ID=$businessId";
                $data = $this->pdo->query($query)->fetchAll(PDO::FETCH_ASSOC);

                if(!empty($data)){
                    $msg = "Got Categories successfully";
                } else {
                    $msg = "Not Found";
                    $status = false;
                }
            }
        }
        catch (PDOException $e) {
            $msg = "Something went wrong";
            $status = false;
            $data = $e->getMessage();
        }
        return get_response($msg, $status, $data);
    }

    // Start of get_cat_level_articles.php
    // get_articles_for_cat_level.php core service is now rewritten in SLIM
    // ( Merch_Cat=2097&Store_No=1&Page=0&Business_ID=3 )

    //Json input businessID, Merch_Cat, Store_No, Brand_No, Cust_No, page

    public function get_cat_level_articles(Request $request){
        $data = array();

        $post = $request->post();
        extract($post);

        $article_result = array();

        if (isset($Brand_No)) {$brandno = $Brand_No;} else { $BrandNo = '';}
        if (isset($Cust_No)) {$cust_no = $Cust_No;} else { $cust_no = '';}

        if ($Page == "0") {
            $start = 0;
            $limit = 5000; //increased the limit for offline functionality
        } else {
            $start = $Page * 5000;
            $limit = 5000; //increased the limit for offline functionality
        }

        // TODO: needed for quantity field in products
        // get the saved cart data for the given buyer
        // try {
        //     $myflag = 0;
        //     $para_array = array();
        //     $para_array[':cust_no'] = $cust_no;
        //     $cartquerystmt = $this->pdo->prepare("select Cart_Id, Cust_No, Cart_Date from User_Cart Where Cust_No=:cust_no");
        //     $cartquerystmt->execute($para_array);
        //     $rows = $cartquerystmt->fetchAll(PDO::FETCH_ASSOC);
        //     if (!empty($rows)) {
        //         $myflag = 1;
        //         $saved_cart = $row['Cart_Data'];
        //         $saved_cart = json_decode($saved_cart, true);
        //     }
        // } catch (PDOException $e) {
        //     $status = false;
        //     $data = $e->getMessage();
        //     return get_response("Something went wrong", $status, $data);
        // }

        //  get the articles for the given category.

        $para_array = array();

        $para_array[':merch_cat'] = $Merch_Cat;
        $para_array[':store_no'] = $Store_No;

        $where = '';
        if (isset($Brand_No)) {$brandno = $Brand_No;
            $para_array[':brand_no'] = $Brand_No;
            $where .= " Article_Master.Brand_ID= :brand_no AND ";
        }

        if (isset($Cust_No)) {$cust_no = $Cust_No;}

        $where .= ' 1 = 1 ';

        try {
            $cat_article_query_stmt = $this->pdo->prepare("WITH cte as (
        SELECT node.Category_ID as cat,
        node.Cat_Desc as 'Desc',
        (COUNT(parent.Cat_Desc) - (sub_tree.depth + 1)) AS depth,
        Is_Leaf(node.Category_ID) as Is_Leaf_Node
        FROM Nested_Category AS node,
                Nested_Category AS parent,
                Nested_Category AS sub_parent,
                (
                        SELECT node.Category_ID, (COUNT(parent.Cat_Desc) - 1) AS depth
                        FROM Nested_Category AS node,
                                Nested_Category AS parent
                        WHERE node.lft BETWEEN parent.lft AND parent.rgt
                                AND node.Category_ID   = :merch_cat
                        GROUP BY node.Category_ID
                        ORDER BY node.lft
                )AS sub_tree
        WHERE node.lft BETWEEN parent.lft AND parent.rgt
                AND node.lft BETWEEN sub_parent.lft AND sub_parent.rgt
                AND sub_parent.Category_ID = sub_tree.Category_ID
        GROUP BY node.Category_ID
        ORDER BY node.lft
        )
        select Article_Master.Article_Desc,
                    REPLACE( Article_Master.Article_Desc, ' ', '' ) as descp,
                    Article_Category.Category_ID as cat,
                    cte.Desc cat_desc,
                    Article_Master.Brand_ID as brand, Article_Master.Article_No as no, Article_Master.Valume as volume,
                    Article_Master.Unit as unit,Article_Master.Image_Url as img, Article_Master.`Large_Image_Url` as large_img, Store_Listing.Unit_Price as price,
                    Store_Listing.Offer_Price as offer, Store_Listing.Out_Of_Stock,
                    Article_Master.Article_Short_Desc AS short_desc,
                    Article_Master.Case_Size AS case_size,
                    Article_Master.Tech_Spec AS tech_spec,
                    Article_Master.Product_PDF AS product_pdf,
                    Article_Master.Product_Type AS product_type,
                    Article_Master.Composition AS composition,
                    Store_Listing.Unit_Rate as unit_rate,
                    Store_Listing.Offer_Rate as offer_rate,
                    Article_Master.GST as gst,
                    Article_Master.V_Mfg as make,
                    Article_Master.V_Mfg_Month_Year as year,
                    Article_Master.V_Model as model,
                    Article_Master.OEM_Part_No as oemno,
                    Get_Brand_Name(Article_Master.Brand_ID) as brandname,
                    Get_Brand_Store(Article_Master.Brand_ID) as split_store_no
                    from Article_Master,Article_Category,Store_Listing, cte
                    where Article_Master.Article_No=Store_Listing.Article_No AND
                        Store_Listing.Article_No=Article_Category.Article_No AND
                        Article_Master.Article_No=Article_Category.Article_No AND
                        Article_Category.Category_ID = cte.cat AND
                        Article_Master.Status='A' AND
                        Store_Listing.Status = 'A' AND
                        Article_Category.Status= 'A' AND
                        Store_Listing.`Store_No` = :store_no AND " . $where . " ORDER BY Article_Master.Article_Desc, Article_Master.Approx_Weight ASC limit " . $start . " , " . $limit . ";");

            $cat_article_query_stmt->execute($para_array);
            $rows = $cat_article_query_stmt->fetchAll(PDO::FETCH_ASSOC);

        } catch (PDOException $e) {
            $status = false;
            $data = $e->getMessage();
            return get_response("Something went wrong", $status, $data);
        }

        if (empty($rows)) {
            $msg = 'Products not available.';
            $status = false;
            return get_response($msg, $status, $data);
        } else {

            // $rows is an array that has the categories and all products.

            $catarr = array();
            $output = array();

            // All articles
            $max_page_no = 0;
            $main_count = count($rows);

            if ($main_count > 0) {
                $max_page_no = ceil($main_count / 5000);
            }

            $output[0]['cat'] = $Merch_Cat;
            $output[0]['products'] = $rows;
            $output[0]['pages'] = $max_page_no;
            $output[0]['product_count'] = $main_count;

            foreach ($rows as $key => $val) {
                // array of all categories
                $currcat = $rows[$key]['cat'];

                if (!in_array($currcat, $catarr)) {
                    $catarr[] = $currcat;
                }
                // array of all articles
                $articleids[] = $rows[$key]['no'];

                $output[0]['products'][$key]['slabs_flag'] = "N";
                $output[0]['products'][$key]['slabs'][0]['Article_No'] = $output[0]['products'][$key]['no'];
                $output[0]['products'][$key]['slabs'][0]['Min_Qty'] = 1;
                $output[0]['products'][$key]['slabs'][0]['Max_Qty'] = 9999;
                $output[0]['products'][$key]['slabs'][0]['SK_Offer_Price'] = $output[0]['products'][$key]['offer'];
                $output[0]['products'][$key]['slabs'][0]['Offer_From'] = "";
                $output[0]['products'][$key]['slabs'][0]['Offer_To'] = "";

                $output[0]['products'][$key]['more_images'] = array();

                $output[0]['products'][$key]['where_use'] = array();

            }

            $outputctr = 1;

            // populate the output with categories
            foreach ($catarr as $key => $val) {
                $output[$outputctr]['cat'] = $val;
                $outputctr++;
            }

            // TODO: get 'slabs' data for all articles

            // get 'more images' data for all articles $articleids

            $in = str_repeat('?,', count($articleids) - 1) . '?';
            $sqlsmt = "SELECT Article_No, Large_Image_Url FROM Article_More_Images WHERE Article_No IN ($in)";
            $stm = $this->pdo->prepare($sqlsmt);

            try {
                $stm->execute($articleids);
                $moreimagerows = $stm->fetchAll(PDO::FETCH_ASSOC);

                if (count($moreimagerows) > 0) {
                    $moreimagearticlevals = array_column($moreimagerows, 'Article_No');
                    $moreimagearticlearray = array_keys(array_column($moreimagerows, 'Article_No'));
                } else {
                    $moreimagearticlearray = array();
                }

            } catch (PDOException $e) {
                $status = false;
                $data = $e->getMessage();
                return get_response("Something went wrong", $status, $data);
            }
            // get 'where use' data for all articles

            $in = str_repeat('?,', count($articleids) - 1) . '?';
            $whereusesqlsmt = "SELECT Article_No , V_Mfg as make, V_Mfg_Month_Year as year, V_Model as model FROM Article_Where_Use WHERE Article_No IN ($in) ORDER BY V_Mfg,V_Model,V_Mfg_Month_Year;";
            $whereusestm = $this->pdo->prepare($whereusesqlsmt);

            try {
                $whereusestm->execute($articleids);
                $whereuserows = $whereusestm->fetchAll(PDO::FETCH_ASSOC);

                if (count($whereuserows) > 0) {
                    $whereusearticlevals = array_column($whereuserows, 'Article_No');
                    $whereusearticlearray = array_keys(array_column($whereuserows, 'Article_No'));
                } else {
                    $whereusearticlearray = array();
                }

            } catch (PDOException $e) {
                $status = false;
                $data = $e->getMessage();
                return get_response("Something went wrong", $status, $data);
            }

            // populate the articles and their count for each category
            foreach ($output[0]['products'] as $key => $val) {

                // populate the slabs, more_images and where_use
                // Populate the more images array
                if (in_array($output[0]['products'][$key]['no'], $moreimagearticlevals)) {
                    $moreimagearray = array_keys($moreimagearticlevals, $output[0]['products'][$key]['no']);
                    if (!empty($moreimagearray)) {
                        foreach ($moreimagearray as $moreimagekey => $moreimageval) {
                            array_push($output[0]['products'][$key]['more_images'], $moreimagerows[$moreimageval]);
                        }
                    }
                }
                // Populate the where use array

                if (in_array($output[0]['products'][$key]['no'], $whereusearticlevals)) {
                    $whereusearray = array_keys($whereusearticlevals, $output[0]['products'][$key]['no']);
                    if (!empty($whereusearray)) {
                        foreach ($whereusearray as $whereusekey => $whereuseval) {
                            //  $output[0]['products'][$key]['where_use'][] = $whereuserows[$whereuseval];
                            array_push( $output[0]['products'][$key]['where_use'], $whereuserows[$whereuseval]);
                        }
                    }
                    // else {
                    //     $output[0]['products'][$key]['where_use'] = array();
                    // }
                }
                // else {
                //     $output[0]['products'][$key]['where_use'] = array();
                // }

            }

            foreach ($output[0]['products'] as $key => $val) {
                $currcat = $output[0]['products'][$key]['cat'];
                $outputindex = array_search($currcat, array_column($output, 'cat'));
                $output[$outputindex]['products'][] = $output[0]['products'][$key];
                $output[$outputindex]['product_count']++;
            }

            // populate the pages
            foreach ($output as $key => $val) {
                $max_page_no = 0;
                $main_count = $output[$key]['product_count'];

                if ($main_count > 0) {
                    $max_page_no = ceil($main_count / 5000);
                    $output[$key]['pages'] = $max_page_no;
                }
            }

            $data = $output;
            $msg = 'Success';
            $status = true;

            return get_response($msg, $status, $data);
        }
    }
}
