<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;
use PDOException;

class FavouriteController extends Controller
{
    public function save_favourite(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);

        $json_input_decode = array();

        $json_input_decode[':cart_data'] = $cart_data;

        $cust_no = $cart_data['cust_no'];
        try{
            if(isset($cart_data['stores']) && !empty($cart_data['stores'])){
                $final_array=array();
                for($i=0;$i<sizeof($cart_data['stores']);$i++){

                    $StoreNo=$cart_data['stores'][$i]['store_no'];

                    for($j=0;$j<sizeof($cart_data['stores'][$i]['items']);$j++)
                    {
                        $ArticleNo=$cart_data['stores'][$i]['items'][$j]['no'];
                        $quantity= $cart_data['stores'][$i]['items'][$j]['quantity'];

                        $row[0]['Article_No']=$ArticleNo;
                        $row[0]['Store_No']=$StoreNo;
                        $row[0]['quantity']=$quantity;
                        array_push($final_array, $row);

                    }
                    $data = updateFavouriteProductsCode($this->pdo,$cust_no, $StoreNo, $final_array);
                }
            }
            else{
                $final_array=array();
                $data = updateFavouriteProductsCode($this->pdo,$cust_no, null, $final_array);
            }

            $msg="Favourite cart updated successfully";
        }
        catch (PDOException $e) {
            $status = false;
            $data = $e->getMessage();
            $msg = "Something went wrong";
        }
        return get_response($msg, $status, $data);
    }

    /******** JSON INPUT
    {
    "Cust_No":382,
    "City_Code":2
    }
     ********/
    public function get_favourite(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);
        try {
            $stmt = $this->pdo->prepare("select * from User_Love where Cust_No=$Cust_No");
            $stmt->execute();
            $row = $stmt->fetch(PDO::FETCH_ASSOC);
            $cart=$row['Love_Data'];
            $array=json_decode($cart);
            if(empty($array)){
                $array = [];
            }
            $cart_array=array();
            $i=0;
            $cart_array['cust_no']=$Cust_No;
            $City_Code   = $City_Code? $City_Code:'';
            $cart_array['stores']=array();
            $i=0;
            $business_no = $Business_ID? $Business_ID:''; //mmb-android-pricing
            $store=array();
            $i=0;
            foreach($array as $value){
                foreach($value as $newa){

                    $favouriteStoreNo = $newa->Store_No;

                    if(!empty($store_id)){
                        if($favouriteStoreNo == $store_id){
                            $store[$i]=$favouriteStoreNo; break;
                        }
                    }else{
                        $store[$i]=$favouriteStoreNo;
                    }

                    $i=$i+1;
                }
            }
            $store=array_unique($store);

            //mmb-android-pricing
            $queryPricing = $this->pdo->prepare("Select Config_Value from Business_Config_Master
                where Business_Id = $business_no
                and   Config_Attribute='PRICING'
                and   Status='A'");
            $queryPricing->execute();
            $pricingMode ='DECENTRALIZED';
            $pricingResult = $queryPricing->fetch(PDO::FETCH_ASSOC);
            $pricingMode   = $pricingResult['Config_Value'];
//mmb-android-pricing
            foreach($store as $value){
                $mystore=array();
                $StoreNo=$value;
                $mystore['store_no']=$StoreNo;

                //array_push($cart_array['stores'][$i]['store_no'], $StoreNo);
                $mystore['items']=array();
                foreach($array as $value){
                    foreach($value as $new){
                        if($new->Store_No==$StoreNo){
                            $getCustType = getCustType($this->pdo, $Cust_No, $StoreNo);
                            $ArticleNo=$new->Article_No;
                            //$Quantity=$new->quantity;

                            $stmt1 = $this->pdo->prepare("SELECT
                                AM.`Article_No` as no,
                                AM.`Valume` as vol,
                                AM.`Unit` as unit,
                                AM.`Merch_Cat` as cat,
                                AM.`Image_Url` as image,
                                AM.`Large_Image_Url` as large_img,
                                AM.`Article_Desc` as descp,
                                AM.`Brand_ID` as brand,
                                SM.`Store_Name` as store_name,
                                SM.`Min_Order_Amt` as min_order_amt,
                                SM.`Min_Order_Amt_Without_Chrg` as min_order_amt_without_chrg,
                                SM.`Delivery_Charge` as delivery_charge,
                                -- SL.`Unit_Price` as unit_price,     //mmb-androidpricingfinal
                                -- SL.`Offer_Price`  as offer_price,  //mmb-androidpricingfinal
                                SL.`Out_Of_Stock` as outofstock,
                                AM.Article_Short_Desc AS short_desc,
                                AM.Case_Size AS case_size,
                                AM.Tech_Spec AS tech_spec,
                                AM.Product_PDF AS product_pdf,
                                AM.Product_Type AS product_type,
                                AM.Composition AS composition,
                                -- SL.Unit_Rate as unit_rate,
                                -- SL.Offer_Rate as offer_rate,
                                -- Get_GST_Rate_Article(AM.Article_No) as gst,
                                AM.GST as gst,
                                AM.Dietary_Code as dietary_code ,
                                AM.V_Mfg as make,
                                AM.V_Mfg_Month_Year as year,
                                AM.V_Model as model,
                                AM.OEM_Part_No as oemno,
                                Get_Brand_Name(AM.Brand_ID) as brandname,
                                Split_Store_No as split_store_no,
                                Cust_Type as cust_type,
                                SCAP.Offer_Price as offer_price,
                                SCAP.Offer_Rate as offer_rate,
                                SCAP.Unit_Price as unit_price,
                                SCAP.Unit_Rate as unit_rate,
                                SCAP.Scheme_Price as scheme_price,
                                Scheme_ID as scheme_id,
                                Cust_Margin as cust_margin,
                                Scheme_Name as scheme_name

                                FROM `Article_Master` As AM
                                INNER JOIN `Store_Listing` AS SL ON AM.`Article_No` = SL.`Article_No`
                                 INNER JOIN Store_Cust_Article_Price SCAP on SCAP.Article_No = AM.Article_No
                                 AND SCAP.Store_No = '$StoreNo'
                                 AND (SCAP.Cust_No = 0
                                 AND SCAP.Cust_Type = '$getCustType')
                                INNER JOIN `Store_Master` SM ON SL.`Store_No` = SM.`Store_No`
                                LEFT OUTER JOIN Store_City_Article SC on SC.Store_No = '$StoreNo' AND  SC.Article_No = '$ArticleNo' and SC.City_Code = '$City_Code'
                                WHERE AM.`Article_No` = '$ArticleNo' AND SL.`Store_No` = '$StoreNo' AND
                                AM.Status = 'A' AND
                                ifnull(SC.Show_Flag,1)>0 AND SCAP.Offer_Price>0 AND
                                -- Is_Article_In_Catalog('$StoreNo','$City_Code',SL.Article_No) >0 AND
                                AM.Status = 'A' AND SL.Status = 'A'");
                            //$stmt1->debugDumpParams();
                            $stmt1->execute();
                            $row = $stmt1->fetch(PDO::FETCH_ASSOC);



                            if(!empty($row))
                            {
                                $mystore['store_name']=$row['store_name'];
                                $mystore['min']=$row['min_order_amt'];
                                $mystore['min_free']=$row['min_order_amt_without_chrg'];
                                $mystore['charge']=$row['delivery_charge'];
                                $volume=floatval($row['vol']);
                                $row['volume']=(string)$volume;
                                $row['out_of_stock'] = intval($row['outofstock']);

                                unset($row['vol']);
                                unset($row['store_name']);
                                unset($row['min_order_amt']);
                                unset($row['min_order_amt_without_chrg']);
                                unset($row['delivery_charge']);
                                unset($row['outofstock']);

                                $articleNo = $row['no'];
                                $queryAllArticleSlab = $this->pdo->prepare("SELECT
                          Article_No,
                          Min_Qty,
                          Max_Qty,
                          SK_Offer_Price,
                          Offer_From,
                          Offer_To
                    FROM Article_Offers
                    WHERE Article_No = '$articleNo' AND Status = 'A' AND Supplier_No = '$StoreNo' ORDER BY Min_Qty ASC");

                                // $resultAllArticleSlab  = mysqli_query($con,$queryAllArticleSlab);
                                $queryAllArticleSlab->execute();
                                $resultAllArticleSlab = $queryAllArticleSlab->fetchAll(PDO::FETCH_ASSOC);
                                //  $recordsAllArticleSlab = array();
                                // if(count($recordsAllArticleSlab) > 0){
                                //     while($dataAllArticleSlab     = mysqli_fetch_assoc($resultAllArticleSlab))
                                //     {
                                //             array_push($recordsAllArticleSlab, $dataAllArticleSlab);
                                //     }
                                //     $recordsAllArticleSlab = $resultAllArticleSlab ;

                                // }

                                $index      = 0;
                                $slabs      = array();
                                $minQty     = array();
                                $slabsFlag  = "N";
                                foreach($resultAllArticleSlab as $value){
                                    if($row['no'] == $value['Article_No']){
                                        unset($value['Article_No']);
                                        array_push($minQty, $value['Min_Qty']);
                                        array_push($slabs, $value);
                                        $index = $index+1;
                                        $slabsFlag = "Y";
                                    }

                                }

                                $maxQty = "9999";
                                $defaultSlab = array();
                                if($slabsFlag == 'N' OR min($minQty) >= 2) {

                                    if((COUNT($minQty) > 0) && (min($minQty) >= 2)){
                                        $maxQty = min($minQty) - 1;
                                    }
                                    $defaultSlab['Article_No']      = $row['no'];
                                    $defaultSlab['Min_Qty']         = "1";
                                    $defaultSlab['Max_Qty']         = (string)$maxQty;
                                    //$defaultSlab['Supplier_Price']    = $row['unit_price'];
                                    $defaultSlab['SK_Offer_Price']  = $row['offer_price'];
                                    $defaultSlab['Offer_From']      = "";
                                    $defaultSlab['Offer_To']        = "";
                                }

                                $row['slabs_flag']      = $slabsFlag;

                                if(COUNT($defaultSlab)>0){
                                    array_unshift($slabs,$defaultSlab);
                                }
                                if(COUNT($slabs)>0){
                                    $row['slabs']=$slabs;
                                }

                                //Article More Images - Added by Meenal Barve 16th August 2018
                                //$article= $row1['no'];
                                $more_images=array();
                                $queryMoreArticleImages = $this->pdo->prepare("SELECT
                            Large_Image_Url
                            FROM Article_More_Images
                            WHERE Article_No = '$ArticleNo' ORDER BY Id ");
                                //  $resultAllArticleImages  = mysqli_query($con,$queryMoreArticleImages);
                                $recordsAllArticleImages = array();
                                $queryMoreArticleImages->execute();
                                $resultAllArticleImages = $queryMoreArticleImages->fetchAll(PDO::FETCH_ASSOC);

                                // if (count($resultAllArticleImages) >0) {
                                // while ($dataAllArticleImages = $resultAllArticleImages)
                                //     {
                                //     array_push($more_images,$dataAllArticleImages);
                                //     }
                                // }

                                $row['more_images'] = $resultAllArticleImages;
                                $where_use=array();
                                $queryWhereUse = $this->pdo->prepare("SELECT
                        V_Mfg as make,
                        V_Mfg_Month_Year as year,
                        V_Model as model
                        FROM Article_Where_Use
                        WHERE Article_No = '$ArticleNo' ORDER BY V_Mfg,V_Model,V_Mfg_Month_Year");
                                // $resultAllWhereUse  = mysqli_query($con,$queryWhereUse);
                                $queryWhereUse->execute();
                                $resultAllWhereUse = $queryWhereUse->fetchAll(PDO::FETCH_ASSOC);
                                /*if (count($resultAllWhereUse) >0) {
                                while ($dataAllWhereUse =$resultAllWhereUse)
                                    {
                                    array_push($where_use,$dataAllWhereUse);
                                    }
                                }*/

                                $row['where_use'] = $resultAllWhereUse;

                                //Call Procedure to get Article Price -apply all schemes whichever applicable
                                $currarticle= $ArticleNo;
                                //Procedure parameters in order - Article no,store no,customer no,qty and casesize
                                $articleqty = 1;//$Quantity;
                                if ($articleqty =='') {
                                    $articleqty = 1; //by default qty should be 1
                                }

                                $row['split_store_no'] = $row['split_store_no'];

                                // sph-offlinepilot-01
                                $queryArticleSchemes = $this->pdo->prepare("SELECT Store_No, Business_No, Cust_No, Cust_Type, Offer_Price, Offer_Rate, Unit_Price, Unit_Rate, Scheme_Price, Scheme_ID, Cust_Margin,Scheme_Name
                            FROM Store_Cust_Article_Price SCAP
                            WHERE SCAP.Article_No = '$currarticle'
                            AND SCAP.Store_No = '$StoreNo'
                            AND SCAP.Cust_No = '$Cust_No'
                            ORDER BY SCAP.Cust_No DESC");

                                $queryArticleSchemes->execute();
                                $resultArticleSchemes = array();
                                $resultArticleSchemes = $queryArticleSchemes->fetch(PDO::FETCH_ASSOC);

                                if (!empty($resultArticleSchemes)) {
                                    $dataArticleSchemes = $resultArticleSchemes;

                                    //mmb-android-pricing
                                    $row['unit_price']  = $dataArticleSchemes['Unit_Price'];
                                    $row['unit_rate']   = $dataArticleSchemes['Unit_Rate'];
                                    //mmb-android-pricing
                                    $row['offer_price'] = $dataArticleSchemes['Offer_Price'];
                                    $row['offer_rate']  = $dataArticleSchemes['Offer_Rate'];
                                    $row['scheme_price']= $dataArticleSchemes['Scheme_Price'];
                                    $row['scheme_id']   = $dataArticleSchemes['Scheme_ID'];
                                    $row['scheme_name'] = $dataArticleSchemes['Scheme_Name'];
                                    //$row['cust_type']   = $dataArticleSchemes['Cust_Type'];      //pricing
                                    $row['cust_margin'] = $dataArticleSchemes['Cust_Margin'];  //pricing
                                }

                                array_push($mystore['items'], $row);
                            }
                        }
                    }
                }
                array_push($cart_array['stores'], $mystore);

            }
            if(count($cart_array['stores'])>0){
                $return['cart_data']=$cart_array;
                $return['flag']=1;
                $msg = 'Success';
            }else{
                $return['flag']=0;
                $msg = 'No Data Found';
            }

        } catch (PDOException $e) {
            $status = false;
            $return = $e->getMessage();
            return get_response("Something went wrong", $status, $return);
        }

        return get_response($msg, $status, $return);
    }
}
