<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;

class PackageVersionController extends Controller
{
    public function getPackageVersion(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);
        //header_remove("Cache-Control");

        $stmt = $this->pdo->prepare("SELECT Build_No as vNo, Min_Build_No as mvNo,App_Link as applink, DB_Mode as dbMode, Old_Package_Name, Old_Package_Icon from Config_Master WHERE Package_ID=?");

        if(isset($packageid)){
            $stmt->execute([$packageid]);
            $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);

            if(!empty($arr)) {

                $msg = 'Get Package Version No Successful';
                $data['vNo'] = $arr['0']['vNo'];
                $data['mvNo'] = $arr['0']['mvNo'];
                $data['dbMode'] = $arr['0']['dbMode'];
                $data['applink'] = $arr['0']['applink'];
                $data['oldPackageName'] = $arr['0']['Old_Package_Name'];
                $data['oldPackageIcon'] = $arr['0']['Old_Package_Icon'];
                $status = true;


            } else {
                $msg = 'Package Name not Found';
                $status = false;
            }
        } else {
            $msg = 'Invalid Package ID';
            $status = false;
        }

        $stmt = null;

        return get_response($msg, $status, $data);
    }
}
