<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;
use PDOException;

class ProductController extends Controller
{
    public function get_offered_products(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);
        $s_array = array();
        // print_r($post);
        try
        {
            if (isset($Store_No)) {
                $storeNo = $Store_No;
                $fsoNo ='';
                if (isset($FSO_No))
                    $fsoNo = $FSO_No;
                $loginType ='';
                if (isset($Login_Type))
                    $loginType = $Login_Type;
                $cust_no 	= 0;
                if (isset($Cust_No)) {
                    $cust_no = $Cust_No;
                }
                // $Business_ID 	= 0;
                if (isset($Business_ID)) {
                    $business_no = $Business_ID;
                }

                $CityCode = 0;
                if (isset($City_Code) && $City_Code > 0) {
                    $CityCode = $City_Code;
                }

                $getCustType = getCustType($this->pdo, $cust_no, $storeNo);


                if ($loginType == 'Buyer') {
                    ##Get all product on offer
                    $query = $this->pdo->prepare("SELECT DISTINCT Article_Master.Article_Desc,Article_Master.Status,REPLACE( Article_Master.Article_Desc, '\\\', '' ) AS descp,
	            Article_Master.Brand_ID As brand, Article_Master.Article_No As no, Article_Master.Valume As volume,
	            Article_Master.Unit AS unit,Article_Master.Image_Url As img, Article_Master.`Large_Image_Url` As large_img, Article_Master.`Approx_Weight` AS approx_weight, Store_Listing.Unit_Price as unit_price,
	            Store_Listing.Offer_Price As offer_price1,
				Store_Listing.Out_Of_Stock,
				Article_Master.V_Mfg AS make,
				Article_Master.V_Mfg_Month_Year as year,
				Article_Master.V_Model As model,
				Article_Master.OEM_Part_No As oemno,
				Article_Master.Article_Short_Desc AS short_desc,
				Article_Master.Case_Size AS case_size,
				Article_Master.Tech_Spec AS tech_spec,
				Article_Master.Product_PDF AS product_pdf,
				Article_Master.Product_Type AS product_type,
				Article_Master.Composition AS composition,
				Store_Listing.Unit_Rate AS unit_rate1,
				Store_Listing.Offer_Rate AS offer_rate1,
				Article_Master.GST AS gst,
				Article_Master.Dietary_Code AS dietary_code,
				Get_Brand_Name(Article_Master.Brand_ID) AS brandname,
				SC.Split_Store_No As split_store_no,
				Cust_Type ,
				SCAP.Offer_Price AS offer_price,
				SCAP.Offer_Rate AS offer_rate,
				SCAP.Unit_Price AS unit_price ,
				SCAP.Unit_Rate  AS unit_rate,
				SCAP.Scheme_Price AS scheme_price,
				Scheme_ID AS scheme_id,
				Cust_Margin ,
				Scheme_Name AS scheme_name
	            FROM Article_Master
	            INNER join Store_Listing ON Article_Master.Article_No=Store_Listing.Article_No
	            INNER JOIN Store_Cust_Article_Price SCAP ON SCAP.Article_No = Article_Master.Article_No
							AND SCAP.Store_No = '$storeNo'
							AND (SCAP.Cust_No = 0
							AND SCAP.Cust_Type = '$getCustType')
	            LEFT OUTER JOIN Store_City_Article SC ON SC.Store_No = Store_Listing.Store_No AND Store_Listing.Article_No = SC.Article_No AND SC.City_Code = '$CityCode'
	            WHERE Store_Listing.Store_No =" . $storeNo . " AND ifnull(SC.Show_Flag,1)>0 AND  SCAP.Offer_Price>0 AND Store_Listing.Is_Offered = 'Y' AND Store_Listing.Out_Of_Stock != 1 AND Article_Master.Status = 'A' AND Store_Listing.Status = 'A'  ");
                }
                else {
                    $query = $this->pdo->prepare("SELECT DISTINCT Article_Master.Article_Desc,Article_Master.Status,REPLACE( Article_Master.Article_Desc, '\\\', '' ) AS descp,
	            Article_Master.Brand_ID AS brand, Article_Master.Article_No AS no, Article_Master.Valume AS volume,
	            Article_Master.Unit AS unit,Article_Master.Image_Url AS img, Article_Master.`Large_Image_Url` AS large_img, Article_Master.`Approx_Weight` AS approx_weight,
				/* Store_Listing.Unit_Price AS unit_price1,
	               Store_Listing.Offer_Price AS offer_price1,*/
				Store_Listing.Out_Of_Stock,
				Article_Master.V_Mfg AS make,
				Article_Master.V_Mfg_Month_Year AS year,
				Article_Master.V_Model AS model,
				Article_Master.OEM_Part_No AS oemno,
				Article_Master.Article_Short_Desc AS short_desc,
				Article_Master.Case_Size AS case_size,
				Article_Master.Tech_Spec AS tech_spec,
				Article_Master.Product_PDF AS product_pdf,
				Article_Master.Product_Type AS product_type,
				Article_Master.Composition AS composition,
				/*Store_Listing.Unit_Rate AS unit_rate,*/
				/* Store_Listing.Offer_Rate as offer_rate,*/
				Article_Master.GST AS gst,
				Article_Master.Dietary_Code AS dietary_code,
				Get_Brand_Name(Article_Master.Brand_ID) AS brandname,
				SC.Split_Store_No AS split_store_no,
				Cust_Type ,
				SCAP.Offer_Price AS offer_price,
				SCAP.Offer_Rate AS offer_rate,
				SCAP.Unit_Price AS unit_price ,
				SCAP.Unit_Rate  AS unit_rate,
				SCAP.Scheme_Price AS scheme_price,
				Scheme_ID AS scheme_id,
				Cust_Margin ,
				Scheme_Name AS scheme_name
	            FROM Article_Master
	            INNER JOIN Store_Listing ON Article_Master.Article_No=Store_Listing.Article_No
	            INNER JOIN Store_Cust_Article_Price SCAP ON SCAP.Article_No = Article_Master.Article_No
							AND SCAP.Store_No = '$storeNo'
							AND (SCAP.Cust_No = 0
							AND SCAP.Cust_Type = '$getCustType')
	            INNER JOIN Article_Category ON Article_Master.Article_No=Article_Category.Article_No
	            LEFT OUTER JOIN Store_City_Article SC on SC.Store_No = Store_Listing.Store_No AND Store_Listing.Article_No = SC.Article_No AND SC.City_Code = '$CityCode'
	            WHERE Store_Listing.Store_No =" . $storeNo . "
	            AND ifnull(SC.Show_Flag,1)>0
				AND Store_Listing.Is_Offered = 'Y'
				AND Article_Category.Status='A'
				AND Article_Category.Level_1 IN (SELECT Filter_ID FROM BBC_Org_User_Filters
				                                                             where Filter_Type = 'Category'
	                                                                         AND   Store_No='$storeNo'
	                                                                         AND   FSO_No='$fsoNo'
	                                                                         AND   Status='A'
	                                                                         )
	            AND Article_Master.Brand_ID IN (Select Filter_ID FROM BBC_Org_User_Filters
	                                                                         where Filter_Type= 'Brand'
	                                                                         AND   Store_No='$storeNo'
	                                                                         AND   FSO_No='$fsoNo'
	                                                                         AND   Status='A'
	                                                                         )
	            AND Store_Listing.Out_Of_Stock != 1
	            AND Article_Master.Status = 'A'
				AND Store_Listing.Status = 'A'
				AND   SCAP.Offer_Price>0 ");
                }
                $query->execute();
                $resultall = $query->fetchAll(PDO::FETCH_ASSOC);
                // print_r($query);
                //   	die();
                if ($resultall) {
                    $k = 0;
                    $s_array = array();
                    $queryPricing = $this->pdo->prepare("Select Config_Value from Business_Config_Master
					where Business_Id = '$business_no'
					and   Config_Attribute='PRICING'
					and   Status='A'");
                    $queryPricing->execute();
                    $resultPricing = $queryPricing->fetch(PDO::FETCH_ASSOC);
                    $pricingMode ='DECENTRALIZED';
                    if($resultPricing){
                        $pricingMode   = $resultPricing['Config_Value'];

                    }
                    $row1 = $resultall;
                    if(!empty($row1))
                    {
                        foreach($row1 as $row1) {


                            $s_array[$k]['article_no'] = $row1['no'];
                            $s_array[$k]['desc'] = $row1['descp'];
                            $s_array[$k]['brand'] = $row1['brand'];
                            $s_array[$k]['volume'] = (string)(floatval($row1['volume']));
                            $s_array[$k]['unit'] = $row1['unit'];
                            $s_array[$k]['img'] = $row1['img'];
                            $s_array[$k]['large_img'] = $row1['large_img'];
                            $s_array[$k]['offer_price'] = $row1['offer_price'];
                            $s_array[$k]['offer_rate'] = $row1['offer_rate'];
                            $s_array[$k]['unit_rate'] = $row1['unit_rate'];
                            $s_array[$k]['unit_price'] = $row1['unit_price'];

                            $s_array[$k]['scheme_price']= $row1['scheme_price'];
                            $s_array[$k]['scheme_id']   = $row1['scheme_id'];
                            $s_array[$k]['scheme_name'] = $row1['scheme_name'];
                            $s_array[$k]['split_store_no'] = $row1['split_store_no'];

                            //Call Procedure to get Article Price -apply all schemes whichever applicable
                            $currarticle= $row1['no'];
                            //Procedure parameters in order - Article no,store no,customer no,qty and casesize
                            $articleqty = 1;//$s_array[$k]['quantity'];
                            if ($articleqty =='') {
                                $articleqty = 1; //by default qty should be 1
                            }


                            $queryArticleSchemes = $this->pdo->prepare("SELECT Store_No, Business_No, Cust_No, Cust_Type, Offer_Price, Offer_Rate, Unit_Price, Unit_Rate, Scheme_Price, Scheme_ID, Cust_Margin,Scheme_Name
					FROM Store_Cust_Article_Price SCAP
					WHERE SCAP.Article_No = '$currarticle'
					AND SCAP.Store_No = '$storeNo'
					AND SCAP.Cust_No = '$cust_no'
					ORDER BY SCAP.Cust_No DESC");
                            $queryArticleSchemes->execute();
                            // print_r($queryArticleSchemes);
                            // die();
                            $resultArticleSchemes = array();
                            $resultArticleSchemes = $queryArticleSchemes->fetch(PDO::FETCH_ASSOC);

                            // print_r($row1['Offer_Price'] );
                            // print_r($row1['Offer_Rate'] ); die;

                            // $s_array[$k]['offer_price'] = $row1['Offer_Price'];
                            // $s_array[$k]['offer_rate']	= $row1['Offer_Rate'];
                            // $s_array[$k]['scheme_price']= $row1['Scheme_Price'];
                            // $s_array[$k]['scheme_id']   = $row1['Scheme_ID'];
                            // $s_array[$k]['scheme_name'] = $row1['Scheme_Name'];
                            // //mmb-android-pricing
                            // $s_array[$k]['unit_price']	= $row1['Unit_Price'];
                            // $s_array[$k]['unit_rate']	= $row1['Unit_Rate'];
                            $s_array[$k]['cust_type']   = $row1['Cust_Type'];
                            $s_array[$k]['cust_margin'] = $row1['Cust_Margin'];

                            if (!empty($resultArticleSchemes)) {
                                $dataArticleSchemes = $resultArticleSchemes;

                                // $s_array[$k]['offer_price']	= $dataArticleSchemes['Offer_Price'];
                                // $s_array[$k]['offer_rate']	= $dataArticleSchemes['Offer_Rate'];
                                // $s_array[$k]['scheme_price']= $dataArticleSchemes['Scheme_Price'];
                                // $s_array[$k]['scheme_id']   = $dataArticleSchemes['Scheme_ID'];
                                // $s_array[$k]['scheme_name'] = $dataArticleSchemes['Scheme_Name'];
                                // //mmb-android-pricing
                                // $s_array[$k]['unit_price']	= $dataArticleSchemes['Unit_Price'];
                                // $s_array[$k]['unit_rate']	= $dataArticleSchemes['Unit_Rate'];
                                //$s_array[$k]['cust_type'] = $dataArticleSchemes['Cust_Type'];
                                $s_array[$k]['cust_margin'] = $dataArticleSchemes['Cust_Margin'];
                                //mmb-android-pricing


                            }


                            $s_array[$k]['out_of_stock'] = intval($row1['Out_Of_Stock']);
                            $s_array[$k]['approx_weight'] = $row1['approx_weight'];
                            $s_array[$k]['make']        = $row1['make'];
                            $s_array[$k]['year']        = $row1['year'];
                            $s_array[$k]['model']       = $row1['model'];
                            $s_array[$k]['oemno']       = $row1['oemno'];
                            $s_array[$k]['brandname']   = $row1['brandname'];
                            $s_array[$k]['gst']         = $row1['gst'];
                            $s_array[$k]['dietary_code']         = $row1['dietary_code'];
                            $s_array[$k]['case_size']   = $row1['case_size'];
                            $s_array[$k]['tech_spec']   = $row1['tech_spec'];
                            $s_array[$k]['product_pdf'] = $row1['product_pdf'];
                            $s_array[$k]['product_type']= $row1['product_type'];
                            $s_array[$k]['composition'] = $row1['composition'];


                            $article= $row1['no'];
                            $more_images=array();
                            $queryMoreArticleImages = $this->pdo->prepare("SELECT
					Large_Image_Url
					FROM Article_More_Images
					WHERE Article_No = '$article' ORDER BY Id ");
                            $queryMoreArticleImages->execute();
                            $resultAllArticleImages = $queryMoreArticleImages->fetchAll(PDO::FETCH_ASSOC);



                            if ($resultAllArticleImages) {
                                // while ($resultAllArticleImages)
                                // {
                                array_push($more_images,$resultAllArticleImages);
                                // }
                            }


                            $s_array[$k]['more_images'] = $more_images;
                            //End Images
                            //Article Where Use -
                            //$article= $row1['no'];
                            $where_use=array();
                            $queryWhereUse = $this->pdo->prepare("SELECT
							V_Mfg as make,
							V_Mfg_Month_Year as year,
	                        V_Model as model
							FROM Article_Where_Use
							WHERE Article_No = '$article' ORDER BY V_Mfg,V_Model,V_Mfg_Month_Year");
                            $queryWhereUse->execute();
                            $resultAllWhereUse = $queryWhereUse->fetchAll(PDO::FETCH_ASSOC);
                            // $resultAllWhereUse  = mysqli_query($con,$queryWhereUse);
                            //$recordsAllArticleImages = array();
                            if ($resultAllWhereUse) {
                                // while ($resultAllWhereUse)
                                // {
                                array_push($where_use,$resultAllWhereUse);
                                // }
                            }

                            $s_array[$k]['where_use'] = $where_use;


                            //Article Slabs
                            /* For check the slabs data */
                            $queryArticleSlab = $this->pdo->prepare("SELECT
	                Article_No,
	                Min_Qty,
	                Max_Qty,
	                -- Supplier_Price,
	                SK_Offer_Price,
	                Offer_From,
	                Offer_To

	                FROM Article_Offers

	                WHERE Article_No ='$article' AND Status = 'A' AND Supplier_No = '$storeNo' ORDER BY Min_Qty ASC");
                            $queryWhereUse->execute();

                            $recordsArticleSlab = array();
                            $resultAllWhereUse = $queryWhereUse->fetchAll(PDO::FETCH_ASSOC);
                            if (!empty($resultAllWhereUse)) {
                                // while ($resultAllWhereUse){
                                array_push($recordsArticleSlab, $resultAllWhereUse);
                                // }
                            }

                            $slabs 	= array();
                            $index 	= 0;
                            $minQty = array();
                            $slabsFlag = "N";

                            if(!empty($recordsArticleSlab)) {
                                foreach($recordsArticleSlab as $value){
                                    array_push($minQty, $value['Min_Qty']);
                                    array_push($slabs, $value);
                                    $index = $index+1;
                                    $slabsFlag = "Y";
                                }
                            }

                            #### Default slab for artcile which offer is exists in table
                            $maxQty = "9999";
                            $defaultSlab = array();
                            if($slabsFlag == 'N' OR min($minQty) >= 2) {

                                if((COUNT($minQty) > 0) && (min($minQty) >= 2)){
                                    $maxQty = min($minQty) - 1;
                                }
                                $defaultSlab['Article_No'] 		= $article;
                                $defaultSlab['Min_Qty'] 		= "1";
                                $defaultSlab['Max_Qty'] 		= (string)$maxQty;
                                //$defaultSlab['Supplier_Price'] 	= $row1['price'];
                                $defaultSlab['SK_Offer_Price'] 	= $row1['offer_price'];
                                $defaultSlab['Offer_From'] 		= "";
                                $defaultSlab['Offer_To'] 		= "";
                            }

                            $s_array[$k]['slabs_flag']		= $slabsFlag;

                            if(COUNT($defaultSlab)>0){
                                //$s_array[$k]['slabs'][0] = $defaultSlab;
                                array_unshift($slabs,$defaultSlab);
                            }
                            if(COUNT($slabs)>0){
                                /*foreach ($slabs as $slabsArr) {
                                    array_push($s_array[$k]['slabs'], $slabsArr);
                                } */
                                $s_array[$k]['slabs']= $slabs;
                            }

                            /* End All category article slabs */


                            $k++;
                        }
                    }
                }
                //$response['offeredProducts'] = $s_array;
                if(empty($s_array))
                {
                    $data = $s_array;
                    $status = false;
                    $msg = "Data not found";
                }
                else
                {
                    $data = $s_array;
                    $msg = "Success";
                }

            }
        }catch (PDOException $e)
        {
            $status = false;
            $data = $e->getMessage();
            return get_response("Something went wrong", $status, $data);
        }
        return get_response($msg, $status, $data);
    }
}
