<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;
use PDOException;

class StateController extends Controller
{
    public function get_all_states(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();

        try {
            $stmt = $this->pdo->prepare("select State_Code code, State_Name name
        from   State_Master where Status = 'Y'
        order by State_Name");
            $stmt->execute();
            $data = $stmt->fetchAll(PDO::FETCH_ASSOC);

            if (!empty($data)) {
                $msg = 'Success';
            } else {
                $msg = 'State Data is not available';
                $status = false;
            }

        } catch (PDOException $e) {
            $msg="Something went wrong";
            $status = false;
            $data = $e->getMessage();
        }

        return get_response($msg, $status, $data);
    }
}
