<?php
namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;
use DB;


/******** JSON INPUT
{"City_Code" :}
 ********/ 
class get_all_area extends BaseController
{
    use AuthorizesRequests;
    use DispatchesJobs;
    use ValidatesRequests;
    public function get($uri, $func){
        Route::get($uri, function() use($func){
            $func();
        });
    }
}
/*----------------------get_all_area-----------------------------*/
$app->post('/get_all_area', function ($request, $response, $args) {
    $app = new get_all_area();

    require 'db_connect.php';
    $data = array();
    $status = true;
    $post = $request->getParsedBody();
    extract($post);

    header_remove("Cache-Control");

    try {
        if (!empty($City_Code)) {
            // if json input have city code parameter then all area of given city
            $stmtArea = $pdo->prepare("select Area_Code as code, Area_Name as name , Pincode , COALESCE(Latitude,0) as Latitude , COALESCE(Longitude,0) as Longitude from Area_Master where Status = 'A' and City_Code='$City_Code' order by Area_Name");
        } else {
            // if json input don't have city code parameter then all area get selected
            $stmtArea = $pdo->prepare("select Area_Code code , Area_Name name , Pincode , COALESCE(Latitude,0) as Latitude , COALESCE(Longitude,0) as Longitude  from   Area_Master where Status = 'A' order by Area_Name");
        }
        $stmtArea->execute();
        $data = $stmtArea->fetchAll(PDO::FETCH_ASSOC);
        if (!empty($data)) {
            $msg = 'Success';
            $status = true;
        } else {
            $msg = 'Area Data is not available';
            $status = false;
        }
    } catch (PDOException $e) {
        $msg = "Something went wrong";
        $status = false;
        $data = $e->getMessage();
        // return getResponse($response, "Something went wrong", $status, $data);
    }

    return getResponse($response, $msg, $status, $data);
});

/*----------------------get_all_area-----------------------------*/
