<?php

$business = getBusiness();
$smsLevel = 0;
$businessName = '';
$assetDir = '';
$placeOrderurl = '';
$updateProfileUrl = '';
$cancelRefund = '';
$deliveryChargesUrl = '';
$centralizePricing = false; //default false, true for cbm
$fsoRetailerSignupUrl = '';

$apiBaseUrl = 'b2bservices/sf_services/public/index.php/';
$dUrl = "localhost:8000/";
if($business == 'autod')
{
    $businessName = 'AutoD';
    $smsLevel = "1";
} else if($business == 'chitale') {
    $businessName = 'Chitale';
    $assetDir = '/chitale';
    $smsLevel = "10";
    $centralizePricing = true;
    $_ENV['SLIM_MODE'] = env('APP_ENV', 'development');
    if(isset($_ENV['SLIM_MODE'])){
        if($_ENV['SLIM_MODE'] == 'development'){
            $dUrl = 'https://chitaledev.saralideas.com/';
        } else if($_ENV['SLIM_MODE'] == 'production'){
            $dUrl = 'https://chitaleb2b.saralideas.com/';
        } else {
            $dUrl = 'http://chitale.local.com/';
        }
    } else {
        $dUrl = 'http://chitale.local.com/';
    }

} else if($business == 'familymart') {
    $businessName = 'MyFamilyMart';
    $assetDir = '/familymart';
    $smsLevel = "1";
    $_ENV['SLIM_MODE'] = env('APP_ENV', 'development');
    if(isset($_ENV['SLIM_MODE'])){
        if($_ENV['SLIM_MODE'] == 'development'){
            $dUrl = 'https://familymartdev.saralideas.com/';
        } else if($_ENV['SLIM_MODE'] == 'production'){
            $dUrl = 'https://mfm.saralideas.com/';
        } else {
            $dUrl = 'http://familymart.local.com/';
        }
    } else {
        $dUrl = 'http://familymart.local.com/';
    }
}

$placeOrderurl = $dUrl.$apiBaseUrl.'place_order';
$updateProfileUrl = $dUrl.$apiBaseUrl.'update_profile';
$fsoRetailerSignupUrl = $dUrl.$apiBaseUrl.'fso_retailer_signup';
$cancelRefund = $dUrl.'index.php/store/initiate_refund';
$deliveryChargesUrl = $dUrl.'index.php/user/getdeliverycharge_app';

define("DM_URL",$dUrl);
define("OFFLINE_LOG_URL",'../../../offline_logs'.$assetDir);
define("API_UPDATE_BUYER",$updateProfileUrl);
define('API_ORDER_URL',$placeOrderurl);
define('API_CANCEL_URL',$cancelRefund);
define("DELIVERY_CHARGE_SERVICE_PATH", $deliveryChargesUrl);

define("FSO_RETAILER_SIGNUP_URL",$fsoRetailerSignupUrl);

define("MY_WEBSITE", $businessName);
define("SMS_LEVEL", $smsLevel);

## Offline  Related constants
define("JWT_SWITCH", 'ON'); //switch on off
define("CENTRALIZE_PRICING", $centralizePricing);
define("OFFLINE_PAGE_LENGTH", 1000);
define("JWT_TOKEN_EXPIRE", 86400); //in seconds
define("APP_PACKAGE_NAME_INT", 'com.saralideas.');

## latlong api key
define('MAPS_API_KEY','AIzaSyAmlwORSMOnlDzgehuZCUV42OGbYp81wpA');

//define("RETURN_PATH_UPLOAD", "/images/assets".$assetDir."/return/");
define("RETURN_PATH_UPLOAD", "../../../images/assets".$assetDir."/return/");

defined('TWITTER_FLAG') OR define('TWITTER_FLAG', 'N');
defined('SEND_TWEET') OR define('SEND_TWEET', 'N');
defined('CUSTOMER_CARE_SK') OR define('CUSTOMER_CARE_SK', '');
defined('SKTEAM_SMS_STATUS') OR define('SKTEAM_SMS_STATUS', 'N');
defined('TWEET_API_KEY') OR define('TWEET_API_KEY','hI8PDpYITceAJrlGIQSeMSSV7');
defined('TWEET_API_SECRET') OR define('TWEET_API_SECRET', 'vn95StWQnffbozyt2NcUBzc59X3q3VCBumGNZs63dPEt8CRqaV');
defined('TWEET_ACCESS_TOKEN') OR define('TWEET_ACCESS_TOKEN', '707918919626072064-XtDGUGwCw6f6ghZcrFJiuq4LsOfaPxv');
defined('TWEET_ACCESS_TOKEN_SECRET') OR define('TWEET_ACCESS_TOKEN_SECRET', '4Nxu9cDpHisfovrBRLPKZ0vot3M1YgcUdRrwB5WZza84t');

// TODO:: Need to replace $_SERVER with laravel inbuilt function
if(php_sapi_name() === 'cli' OR defined('STDIN')){
	$domainName="https://mfmlaravel.saralideas.com/";
} else {
	$domainName=(isset($_SERVER['HTTPS']) ? "https://" : "http://").$_SERVER['SERVER_NAME'].'/';
}
define("WEB_ADD_ARTICLE", $_SERVER['DOCUMENT_ROOT']."/images/assets".$assetDir."/article/");
define("GET_ARTICLE", $domainName."images/assets".$assetDir."/article/");

define("ADD_ARTICLE_PDF", $_SERVER['DOCUMENT_ROOT']."/images/assets".$assetDir."/pdf/");
define("GET_ARTICLE_PDF", $domainName."images/assets".$assetDir."/pdf/");
define("CREATED_BY_TMP_USER", 1001);


define("NO_IMG", $domainName."images/assets/No_Image.png");

$store_specific_name = $_GET['store_name'] ?? $businessName;
