<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;
use PDOException;

class ArticleController extends Controller
{
    // json input {Store_No":12,"City_Code":"1",Business_ID":1,Cust_No":1}

    public function get_scheme_articles(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);
        try{
            $record 	= array();
            $cust_no 	= 0;
            $Store_No 	 = $Store_No;

            if (isset($Cust_No)) {
                $cust_no = $Cust_No;
            }

            $CityCode='';  //default Pune City COde
            if (isset($City_Code)) {
                $CityCode    = $City_Code;
            }

            if (isset($Business_ID)) {
                $business_no = $Business_ID;
            }
            /*
            $languageType = $language_type ?? '';

            if($languageType != ''){
                include_once(LANGUAGE_PATH.$languageType.'/article_lang.php');
            }*/

            $getCustType = getCustType($this->pdo, $cust_no, $Store_No);

            $article_result = array();
            $myflag = 0;
            $cat_array = array();

            $query = $this->pdo->prepare("select M.ID,
			A.Buy_Article_No,
			A.Buy_Qty,
			A.Free_Article_No,
			A.Free_Qty, A.Max_Qty,
			AM.Article_Desc,
			REPLACE( AM.Article_Desc, '\\\', '' ) as descp,
			AM.Brand_ID as brand,
			AM.Article_No as no,
			AM.Valume as volume,
			AM.Unit as unit,
			AM.Image_Url as img,
			AM.`Large_Image_Url` as large_img,
			AM.GST as gst,
			SC.Split_Store_No,
			SCAP.Offer_Price ,
			SCAP.Offer_Rate ,
			SCAP.Unit_Price ,
			SCAP.Unit_Rate ,
			SCAP.Scheme_Price ,
			SCAP.Scheme_ID ,
			Cust_Margin ,
			SCAP.Scheme_Name
		from Scheme_Filters F,Scheme_Master M,Scheme_Article_Rules A ,Article_Master AM
		INNER JOIN Store_Cust_Article_Price SCAP on SCAP.Article_No = AM.Article_No
							AND SCAP.Store_No = '$Store_No'
							AND (SCAP.Cust_No = 0
							AND SCAP.Cust_Type = '$getCustType')
		LEFT OUTER JOIN Store_City_Article SC on SC.Store_No = '$Store_No' AND SC.Article_No = AM.Article_No and SC.City_Code = '$CityCode'
		where Scheme_Benefit_Type IN ('BOGO','BOGA')
		and DATE(NOW()) >= DATE(M.Scheme_Valid_From)
		and DATE(NOW()) <= DATE(M.Scheme_Valid_To)
		and M.ID = F.Scheme_ID
		and M.ID = A.Scheme_ID
		AND M.Total_Redeem_Level > (select Count(1)
		From Order_Hdr H , Order_Itm I
		where H.Order_No = I.Order_No
		and H.Cust_No = '$cust_no'
		and Store_No = '$Store_No'
		and Article_No = A.Buy_Article_No
		and Scheme_ID = M.ID)
		and F.Scheme_ID = A.Scheme_ID
		and M.Status='A'
		and F.Filter_Type='Buyer'
		and F.Filter_ID= '$cust_no'
		and M.Store_No= '$Store_No'
		and AM.Article_No = A.Free_Article_No");


            $query->execute();
            // $query->debugDumpParams();
            // die();
            $resultall = $query->fetchAll(PDO::FETCH_ASSOC);
            $allArticleNo 	= array();
            $articleData 	= array();
            $articleNo 		= "";
            // print_r($resultall);
            if(!empty($resultall)){
                for($i=0; $i<count($resultall);$i++)
                {
                    array_push($articleData, $resultall[$i]);
                    array_push($allArticleNo, $resultall[$i]['no']);
                }
                $articleNo = implode("," , $allArticleNo);

                $queryAllArticleSlab = $this->pdo->prepare("SELECT
						Article_No,
						Min_Qty,
						Max_Qty,
						SK_Offer_Price,
						Offer_From,
						Offer_To
					FROM Article_Offers
					WHERE Article_No =$articleNo AND Status = 'A' AND Supplier_No = '$Store_No' ORDER BY Min_Qty ASC)");
                $queryAllArticleSlab->execute();
                $resultAllArticleSlab = $query->fetch(PDO::FETCH_ASSOC);
                $recordsAllArticleSlab 		= array();
                if(!empty($resultAllArticleSlab)){
                    array_push($recordsAllArticleSlab, $resultAllArticleSlab);
                }
            }
            $slabs 	= array();
            $k		= 0;
            $s_array= array();


            foreach($articleData as $row1) {


                $articleNo = 'article_'.$row1['no'];

                if($languageType == '' OR $languageType == 'english'){
                    $s_array[$k]['desc'] 	= $row1['descp'];
                }else{
                    $s_array[$k]['desc'] 	= $lang[$articleNo] ?? $row1['descp'];

                }

                $volume 					= floatval($row1['volume']);
                // $s_array[$k]['cat']			= $row1['cat'];
                $s_array[$k]['ID'] = $row1['ID'];
                $s_array[$k]['Buy_Article_No'] = $row1['Buy_Article_No'];
                $s_array[$k]['Buy_Qty'] = $row1['Buy_Qty'];
                $s_array[$k]['Max_Qty'] = $row1['Max_Qty'];
                $s_array[$k]['Free_Article_No'] = $row1['Free_Article_No'];
                $s_array[$k]['Free_Qty'] = $row1['Free_Qty'];
                $s_array[$k]['brand']		= $row1['brand'];
                $s_array[$k]['no']			= $row1['no'];
                $s_array[$k]['volume']		= (string)$volume;
                $s_array[$k]['unit']		= $row1['unit'];
                $s_array[$k]['img']			= $row1['img'];
                $s_array[$k]['large_img']	= $row1['large_img'];
                // $s_array[$k]['offer']		= $row1['offer'];
                // $s_array[$k]['out_of_stock']= intval($row1['Out_Of_Stock']);

                // $s_array[$k]['short_desc']	= $row1['short_desc'];
                // $s_array[$k]['case_size']	= $row1['case_size'];
                // $s_array[$k]['tech_spec']	= $row1['tech_spec'];
                // $s_array[$k]['product_pdf']	= $row1['product_pdf'];
                // $s_array[$k]['product_type']= $row1['product_type'];
                // $s_array[$k]['composition']	= $row1['composition'];
                // $s_array[$k]['offer_rate']	= $row1['offer_rate'];
                $s_array[$k]['gst']			     = $row1['gst'];
                // $s_array[$k]['make']        = $row1['make'];
                // $s_array[$k]['year']        = $row1['year'];
                // $s_array[$k]['model']       = $row1['model'];
                // $s_array[$k]['oemno']       = $row1['oemno'];
                //$s_array[$k]['brandname']        = $row1['brandname'];
                $s_array[$k]['split_store_no']   = $row1['Split_Store_No'];

                $s_array[$k]['quantity']="";
                if($myflag!="0"){
                    for($ii=0;$ii<sizeof($saved_cart);$ii++){
                        if($saved_cart[$ii][0]['Article_No']==$row1['no'] and $saved_cart[$ii][0]['Store_No']==$Store_No){
                            $s_array[$k]['quantity']=$saved_cart[$ii][0]['quantity'];

                            break;
                        }
                    }
                }

                $currarticle= $row1['no'];
                $articleqty = $s_array[$k]['quantity'];
                if ($articleqty =='') {
                    $articleqty = 1;
                }

                $queryArticleSchemes = $this->pdo->prepare("SELECT Store_No, Business_No, Cust_No, Cust_Type, Offer_Price, Offer_Rate, Unit_Price, Unit_Rate, Scheme_Price, Scheme_ID, Cust_Margin,Scheme_Name
					FROM Store_Cust_Article_Price SCAP
					WHERE SCAP.Article_No = '$currarticle'
					AND SCAP.Store_No = '$Store_No'
					AND SCAP.Cust_No = '$cust_no'
					ORDER BY SCAP.Cust_No DESC");
                $queryArticleSchemes->execute();
                $resultArticleSchemes = array();
                $resultArticleSchemes = $queryArticleSchemes->fetch(PDO::FETCH_ASSOC);


                $s_array[$k]['offer']	    = $row1['Offer_Price'];
                $s_array[$k]['offer_rate']	= $row1['Offer_Rate'];
                $s_array[$k]['scheme_price']= $row1['Scheme_Price'];
                $s_array[$k]['scheme_id']   = $row1['Scheme_ID'];
                $s_array[$k]['scheme_name'] = $row1['Scheme_Name'];
                $s_array[$k]['price']	    = $row1['Unit_Price'];
                $s_array[$k]['unit_rate']	= $row1['Unit_Rate'];
                $s_array[$k]['cust_type']   = $row1['Cust_Type'];
                $s_array[$k]['cust_margin'] = $row1['Cust_Margin'];

                if (!empty($resultArticleSchemes)) {
                    $dataArticleSchemes = $resultArticleSchemes;

                    $s_array[$k]['offer']	    = $dataArticleSchemes['Offer_Price'];
                    $s_array[$k]['offer_rate']	= $dataArticleSchemes['Offer_Rate'];
                    $s_array[$k]['scheme_price']= $dataArticleSchemes['Scheme_Price'];
                    $s_array[$k]['scheme_id']   = $dataArticleSchemes['Scheme_ID'];
                    $s_array[$k]['scheme_name'] = $dataArticleSchemes['Scheme_Name'];

                    $s_array[$k]['price']	    = $dataArticleSchemes['Unit_Price'];
                    $s_array[$k]['unit_rate']	= $dataArticleSchemes['Unit_Rate'];
                    //$s_array[$k]['cust_type']      = $dataArticleSchemes['Cust_Type'];
                    $s_array[$k]['cust_margin'] = $dataArticleSchemes['Cust_Margin'];



                }


                $index 	= 0;
                $slabs 	= array();
                $minQty = array();
                $slabsFlag = "N";
                foreach($recordsAllArticleSlab as $value){
                    if($row1['no'] == $value['Article_No']){
                        unset($value['Article_No']);

                        array_push($minQty, $value['Min_Qty']);

                        array_push($slabs, $value);
                        $index = $index+1;
                        $slabsFlag = "Y";
                    }

                }

                $maxQty = "9999";
                $defaultSlab = array();
                if($slabsFlag == 'N' OR min($minQty) >= 2) {

                    if((COUNT($minQty) > 0) && (min($minQty) >= 2)){
                        $maxQty = min($minQty) - 1;
                    }
                    $defaultSlab['Article_No'] 		= $row1['no'];
                    $defaultSlab['Min_Qty'] 		= "1";
                    $defaultSlab['Max_Qty'] 		= (string)$maxQty;
                    // $defaultSlab['SK_Offer_Price'] 	= $row1['offer'];
                    $defaultSlab['Offer_From'] 		= "";
                    $defaultSlab['Offer_To'] 		= "";
                }

                $s_array[$k]['slabs_flag']		= $slabsFlag;

                if(COUNT($defaultSlab)>0){
                    array_unshift($slabs,$defaultSlab);
                }
                if(COUNT($slabs)>0){

                    $s_array[$k]['slabs']=$slabs;
                }

                $article = $row1['no'];
                $more_images=array();
                $queryMoreArticleImages = $this->pdo->prepare("SELECT
							Large_Image_Url
							FROM Article_More_Images
							WHERE Article_No = '$article' ORDER BY Id ");
                $queryMoreArticleImages->execute();
                $resultAllArticleImages = $queryMoreArticleImages->fetch(PDO::FETCH_ASSOC);
                if (!empty($resultAllArticleImages)) {
                    array_push($more_images,$resultAllArticleImages);
                }
                $s_array[$k]['more_images'] = $more_images;

                $where_use=array();
                $queryWhereUse = $this->pdo->prepare("SELECT
									V_Mfg as make,
									V_Mfg_Month_Year as year,
									V_Model as model
									FROM Article_Where_Use
									WHERE Article_No = '$article' ORDER BY V_Mfg,V_Model,V_Mfg_Month_Year");
                $queryWhereUse->execute();
                $resultAllWhereUse = $queryWhereUse->fetch(PDO::FETCH_ASSOC);
                if (!empty($resultAllWhereUse)) {
                    array_push($where_use,$resultAllWhereUse);
                }

                $s_array[$k]['where_use'] = $where_use;
                $k=$k+1;
            }

            // $cat_array['cat']=$Merch_Cat;
            $cat_array['products']=$s_array;

            // print_r($s_array);die();

            array_push($article_result, $cat_array);


            json_encode($article_result, JSON_UNESCAPED_UNICODE);

            if(!empty($article_result))
            {
                $status = true;
                $data = $article_result;
                $msg = 'Success';
            }
            else
            {
                $status = false;
                $msg = 'Data is not available';
            }
            return get_response($msg, $status, $data);
        }catch (PDOException $e) {
            $status = false;
            $data = $e->getMessage();
            return get_response("Something went wrong", $status, $data);
        }
    }

    // json input {"City_Code":4,"Store_No":12,"Login_Type":"Buyer","Cust_No":416,"Business_ID":1}
   public function search_article_in_store(Request $request){
       $data = array();
       $status = true;
       $post = $request->post();
       extract($post);

       // $Product_Search ='';

       // $Product_Search = $Product_Search;
       $cust_no 	= 0;
       if (isset($Cust_No)) {
           $cust_no = $Cust_No;
       }
       // $Business_ID 	= 0;
       if (isset($Business_ID)) {
           $business_no = $Business_ID;
       }
       $Product_Search = trim($Product_Search);
       $Store_No = $Store_No;
       if (isset($FSO_No))
           $fsoNo = $FSO_No;
       if (isset($Login_Type))
           $loginType = $Login_Type;
       $CityCode='';
       if (isset($City_Code)) {
           $CityCode    = $City_Code;
       }
       try{
           $getCustType = getCustType($this->pdo, $cust_no, $Store_No);
           $whereFilter = '';

           if(!empty($Product_Search))
           {
               $whereFilter .= " AND (AM.`Article_Desc` LIKE '%$Product_Search%' OR AM.OEM_Part_No LIKE '%$Product_Search%')";
           }

           if ($loginType == 'Buyer' || $loginType=='STADM') {
               $query = $this->pdo->prepare("SELECT  DISTINCT
							AM.`Article_No`,
														-- BM.`Brand_Desc`,
							AM.`Valume` as vol,
							AM.`Unit`,
							AM.`Image_Url`,
							AM.`Large_Image_Url` as large_img,
							AM.`Article_Desc`,
							AM.`Status`,
							SL.`Inventory`,
							SL.`Unit_Price`,
							SL.`Offer_Price`,
							SL.`Store_No`,
							SL.`Out_Of_Stock` AS out_of_stock,
							AM.`Article_Desc`,
							AM.Article_Short_Desc AS short_desc,
							AM.Case_Size AS case_size,
							AM.Tech_Spec AS tech_spec,
							AM.Product_PDF AS product_pdf,
							AM.Product_Type AS product_type,
							AM.Composition AS composition,
							SL.Unit_Rate as unit_rate,
							SL.Offer_Rate as offer_rate,
							AM.GST as gst,
							AM.Dietary_Code as dietary_code,
					  		AM.V_Mfg as make,
					  		AM.V_Mfg_Month_Year as year,
					  		AM.V_Model as model,
					  		AM.OEM_Part_No as oemno,
							AM.`Display_Seq_Text`,
							AM.`Display_Seq_No`,
							Get_Brand_Name(AM.Brand_ID) as brandname,
							SC.Split_Store_No as split_store_no,
							SCAP.Cust_Type as cust_type,
							SCAP.Offer_Price as Offer_Price,
							SCAP.Offer_Rate as offer_rate,
							SCAP.Unit_Price as Unit_Price,
							SCAP.Unit_Rate  as unit_rate,
							SCAP.Scheme_Price as scheme_price,
							Scheme_ID as scheme_id,
							Cust_Margin as cust_margin,
							Scheme_Name as scheme_name
							FROM `Article_Master` As `AM`
							LEFT JOIN `Brand_Master` AS `BM` ON AM.`Brand_ID` = BM.`Brand_ID`
							INNER JOIN `Store_Listing` AS `SL` ON AM.`Article_No` = SL.`Article_No`
							INNER JOIN Store_Cust_Article_Price SCAP on SCAP.Article_No = AM.Article_No
							AND SCAP.Store_No = '$Store_No'
							AND (SCAP.Cust_No = 0
							AND SCAP.Cust_Type = '$getCustType')
							LEFT OUTER JOIN Store_City_Article SC on SC.Store_No = SL.Store_No AND SL.Article_No = SC.Article_No and SC.City_Code = '$CityCode'
							WHERE SL.`Store_No` = '$Store_No'
							AND AM.Status = 'A'
							AND SL.Status = 'A'
							and SCAP.Offer_Price>0
							AND ifnull(SC.Show_Flag,1)>0
							$whereFilter
							ORDER BY AM.`Display_Seq_Text`,  AM.`Display_Seq_No`, AM.`Article_Desc`; ");
           }
           else {
               $query = $this->pdo->prepare("SELECT  DISTINCT
							AM.`Article_No`,
							-- BM.`Brand_Desc`,
							AM.`Valume` as vol,
							AM.`Unit`,
							AM.`Image_Url`,
							AM.`Large_Image_Url` as large_img,
							AM.`Article_Desc`,
							AM.`Status`,
							SL.`Inventory`,
							SL.`Unit_Price`,
							SL.`Offer_Price`,
							SL.`Store_No`,
							SL.`Out_Of_Stock` AS out_of_stock,
							AM.Article_Short_Desc AS short_desc,
							AM.Case_Size AS case_size,
							AM.Tech_Spec AS tech_spec,
							AM.Product_PDF AS product_pdf,
							AM.Product_Type AS product_type,
							AM.Composition AS composition,
							SL.Unit_Rate as unit_rate,
							SL.Offer_Rate as offer_rate,
							AM.GST as gst,
							AM.Dietary_Code as dietary_code,
					  		AM.V_Mfg as make,
					  		AM.V_Mfg_Month_Year as year,
					  		AM.V_Model as model,
					  		AM.OEM_Part_No as oemno,
						    AM.`Display_Seq_Text`,
							AM.`Display_Seq_No`,
							Get_Brand_Name(AM.Brand_ID) as brandname,
							SC.Split_Store_No as split_store_no,
							SCAP.Cust_Type as cust_type,
							SCAP.Offer_Price as Offer_Price,
							SCAP.Offer_Rate as offer_rate,
							SCAP.Unit_Price as Unit_Price,
							SCAP.Unit_Rate  as unit_rate,
							SCAP.Scheme_Price as scheme_price,
							Scheme_ID as scheme_id,
							Cust_Margin as cust_margin,
							Scheme_Name as scheme_name
							FROM `Article_Master` As `AM`
							LEFT JOIN `Brand_Master` AS `BM` ON AM.`Brand_ID` = BM.`Brand_ID`
							INNER JOIN `Store_Listing` AS `SL` ON AM.`Article_No` = SL.`Article_No`
							INNER JOIN Article_Category on AM.Article_No=Article_Category.Article_No
							INNER JOIN Store_Cust_Article_Price SCAP on SCAP.Article_No = AM.Article_No
							AND SCAP.Store_No = '$Store_No'
							AND (SCAP.Cust_No = 0
							AND SCAP.Cust_Type = '$getCustType')
							LEFT OUTER JOIN Store_City_Article SC on SC.Store_No = SL.Store_No AND SL.Article_No = SC.Article_No and SC.City_Code = '$CityCode'
							WHERE SL.`Store_No` = '$Store_No'
							AND AM.Status = 'A'
							AND Article_Category.Status='A'
							AND SL.Status = 'A'
							AND ifnull(SC.Show_Flag,1)>0
							and SCAP.Offer_Price>0
							-- AND Find_Parent_At_Level(Article_Category.`Category_ID`,1) IN (Select Filter_ID from BBC_Org_User_Filters
							AND   Article_Category.Level_1 IN (Select Filter_ID from BBC_Org_User_Filters
							where Filter_Type= 'Category'
							and   Store_No='$Store_No'
							and   FSO_No='$fsoNo'
							and   Status='A')
							AND AM.Brand_ID IN (Select Filter_ID from BBC_Org_User_Filters
												where Filter_Type= 'Brand'
												and   Store_No='$Store_No'
												and   FSO_No='$fsoNo'
												and   Status='A')
							$whereFilter
							ORDER BY  AM.`Display_Seq_Text`,  AM.`Display_Seq_No`, AM.`Article_Desc`; ");
           }

           $query->execute();
           //   $query->debugDumpParams(); die();
           $result = $query->fetchAll(PDO::FETCH_ASSOC);
           $records = array();
           // $records = $result;
           $allArticleNo     = array();
           $articleData      = array();
           $articleNo        = "";
           if(!empty($result)){
               // foreach($result as $articleNoData){
               for($i=0; $i<count($result);$i++)
               {
                   array_push($articleData, $result[$i]);
                   array_push($allArticleNo, $result[$i]['Article_No']);
                   // }
               }
               $articleNo = implode("," , $allArticleNo);

               $queryAllArticleSlab = $this->pdo->prepare("SELECT
								  Article_No,
								  Min_Qty,
								  Max_Qty,
								  SK_Offer_Price,
								  Offer_From,
								  Offer_To
								  FROM Article_Offers
								  WHERE Article_No IN($articleNo) AND Status = 'A' AND Supplier_No = '$Store_No' ORDER BY Min_Qty ASC");
               $queryAllArticleSlab->execute();
               // $query->debugDumpParams();
               $resultAllArticleSlab = $query->fetch(PDO::FETCH_ASSOC);
               $recordsAllArticleSlab = array();
               if(!empty($resultAllArticleSlab)){
                   // foreach($resultAllArticleSlab as $dataAllArticleSlab)
                   // {
                   array_push($recordsAllArticleSlab, $resultAllArticleSlab);
                   // }
               }
           }

           $slabs      = array();
           $k          = 0;
           $s_array    = array();
           $queryPricing = $this->pdo->prepare("Select Config_Value from Business_Config_Master
					where Business_Id = '$business_no'
					and   Config_Attribute='PRICING'
					and   Status='A'");
           $queryPricing->execute();
           // $query->debugDumpParams();
           $resultPricing = $queryPricing->fetch(PDO::FETCH_ASSOC);
           $pricingMode ='DECENTRALIZED';
           if(!empty($resultPricing)){
               $pricingMode   = $resultPricing['Config_Value'];
           }
           foreach($articleData as $row) {
               $Valume=floatval($row['vol']);
               $row['Valume']=(string)$Valume;
               // if(isset($row['outofstock'])){
               // $row['Out_Of_Stock'] = intval($row['outofstock']);
               // unset($row['outofstock']);
               // } else {
               // $row['Out_Of_Stock'] = 0;
               // }
               unset($row['vol']);
               $index      = 0;
               $slabs      = array();
               $minQty     = array();
               $slabsFlag  = "N";
               foreach($recordsAllArticleSlab as $value){
                   if($row['Article_No'] == $value['Article_No']){
                       unset($value['Article_No']);
                       array_push($minQty, $value['Min_Qty']);
                       array_push($slabs, $value);
                       $index = $index+1;
                       $slabsFlag = "Y";
                   }
               }

               $maxQty = "9999";
               $defaultSlab = array();
               if($slabsFlag == 'N' OR min($minQty) >= 2) {
                   if((COUNT($minQty) > 0) && (min($minQty) >= 2)){
                       $maxQty = min($minQty) - 1;
                   }
                   $defaultSlab['Article_No'] 		= $row['Article_No'];
                   $defaultSlab['Display_Seq_Text'] 		= $row['Display_Seq_Text'];
                   $defaultSlab['Display_Seq_No'] 		= $row['Display_Seq_No'];

                   $defaultSlab['Min_Qty']             = "1";
                   $defaultSlab['Max_Qty']             = (string)$maxQty;
                   $defaultSlab['SK_Offer_Price']      = $row['Offer_Price'];
                   $defaultSlab['Offer_From']          = "";
                   $defaultSlab['Offer_To']            = "";
               }
               $row['slabs_flag']          = $slabsFlag;
               if(COUNT($defaultSlab)>0){
                   array_unshift($slabs,$defaultSlab);
               }

               if(COUNT($slabs)>0){
                   $row['slabs'] = $slabs;
               }

               /* category wise article slabs */
               $where_use=array();
               $article=$row['Article_No'];
               $queryWhereUse = $this->pdo->prepare("SELECT
						  	V_Mfg as make,
							V_Mfg_Month_Year as year,
							V_Model as model
							FROM Article_Where_Use
							WHERE Article_No = '$article' ORDER BY V_Mfg,V_Model,V_Mfg_Month_Year");
               $queryWhereUse->execute();
               $resultAllWhereUse = $queryWhereUse->fetch(PDO::FETCH_ASSOC);
               //$recordsAllArticleImages = array();
               if (!empty($resultAllWhereUse)) {
                   array_push($where_use,$resultAllWhereUse);
               }

               $row['where_use'] = $where_use;

               //Call Procedure to get Article Price -apply all schemes whichever applicable
               $currarticle= $article;
               //Procedure parameters in order - Article no,store no,customer no,qty and casesize
               $articleqty = 1;//$Quantity;
               if ($articleqty =='') {
                   $articleqty = 1; //by default qty should be 1
               }

               $queryArticleSchemes = $this->pdo->prepare("SELECT Store_No, Business_No, Cust_No, Cust_Type, Offer_Price, Offer_Rate, Unit_Price, Unit_Rate, Scheme_Price, Scheme_ID, Cust_Margin,Scheme_Name
					FROM Store_Cust_Article_Price SCAP
					WHERE SCAP.Article_No = '$currarticle'
					AND SCAP.Store_No = '$Store_No'
					AND  SCAP.Cust_No = '$cust_no'
					ORDER BY SCAP.Cust_No DESC");
               $queryArticleSchemes->execute();
               $resultArticleSchemes = array();
               $resultArticleSchemes = $queryArticleSchemes->fetch(PDO::FETCH_ASSOC);


               if (!empty($resultArticleSchemes)) {
                   $row['Offer_Price'] = $resultArticleSchemes['Offer_Price'];
                   $row['offer_rate']	= $resultArticleSchemes['Offer_Rate'];
                   $row['scheme_price']= $resultArticleSchemes['Scheme_Price'];
                   $row['scheme_id']   = $resultArticleSchemes['Scheme_ID'];
                   $row['scheme_name'] = $resultArticleSchemes['Scheme_Name'];
                   $row['Unit_Price']  = $resultArticleSchemes['Unit_Price'];
                   $row['unit_rate']   = $resultArticleSchemes['Unit_Rate'];
                   //$row['cust_type']   = $resultArticleSchemes['Cust_Type'];
                   $row['cust_margin'] = $resultArticleSchemes['Cust_Margin'];
               }


               $more_images=array();
               $queryMoreArticleImages = $this->pdo->prepare("SELECT
		  Large_Image_Url
		  FROM Article_More_Images
		  WHERE Article_No = '$article' ORDER BY Id ");
               $queryMoreArticleImages->execute();
               $resultAllArticleImages = $queryMoreArticleImages->fetch(PDO::FETCH_ASSOC);
               if (!empty($resultAllArticleImages)) {
                   array_push($more_images,$resultAllArticleImages);
               }
               $row['more_images'] = $more_images;
               $records[] = $row;
           }

           if(!empty($records))
           {
               $msg = "Success";
               $data['articles'] = $records;
           }
           else
           {
               $msg = "Fail";
               $status = false;
               $data['articles'] = $records;
           }

           return get_response($msg, $status, $data);
       }catch (PDOException $e) {
           $status = false;
           $data = $e->getMessage();
           return get_response("Something went wrong", $status, $data);
       }
   }

    // json input {"Merch_Cat":4,"Store_No":12,"City_Code":"1",Business_ID":1,"Brand_No":"1","Cust_No":1,"Page":""}
    public function get_article_for_cat_level(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);
        try{
            $record 	= array();
            $cust_no 	= 0;
            $Merch_Cat 	 = $Merch_Cat;
            $Store_No 	 = $Store_No;
            // $Business_ID = $Business_ID;
            // $BrandNo     = 'null';
            $CityCode    = $City_Code;

            if (isset($Brand_No)) {
                $BrandNo        = $Brand_No ? $Brand_No : 'null';
            }
            if (isset($Cust_No)) {
                $cust_no = $Cust_No;
            }

            // $Business_ID 	= 0;
            if (isset($Business_ID)) {
                $business_no = $Business_ID;
            }

            $languageType = $language_type ?? '';

            if($languageType != ''){
                include_once(LANGUAGE_PATH.$languageType.'/article_lang.php');
            }

            $myflag = 0;
            $query = $this->pdo->prepare("select * from User_Cart Where Cust_No='$cust_no'");
            $query->execute();
            $resultcart = $query->fetch(PDO::FETCH_ASSOC);
            if (!empty($resultcart)) {
                $myflag = 1;
                // $row = mysqli_fetch_assoc($resultcart);
                $saved_cart = $resultcart['Cart_Data'];
                $saved_cart = json_decode($saved_cart, true);
            }

            $page = $Page;
            if ($page == "0") {
                $start = 0;
                $limit = 10; //for Pagination 10 per page
            } else {
                $start = $page * 10;
                $limit = 10; //for Pagination 10 per page
            }
            $article_result = array();


            $query= $this->pdo->prepare("SELECT node.Category_ID as cat,
	node.Cat_Desc as 'Desc',
	(COUNT(parent.Category_ID) - (sub_tree.depth + 1)) AS depth,
	Is_Leaf(node.Category_ID) as Is_Leaf_Node
	FROM Nested_Category AS node,
	        Nested_Category AS parent,
	        Nested_Category AS sub_parent,
	        (
	                SELECT node.Category_ID, (COUNT(parent.Category_ID) - 1) AS depth
	                FROM Nested_Category AS node,
	                        Nested_Category AS parent
	                WHERE node.lft BETWEEN parent.lft AND parent.rgt
	                        AND node.Category_ID   ='$Merch_Cat'
				            /*AND node.Business_ID   ='$Business_ID'
	                        AND parent.Business_ID ='$Business_ID' */
	                GROUP BY node.Category_ID
	                ORDER BY node.lft
	        )AS sub_tree
	WHERE node.lft BETWEEN parent.lft AND parent.rgt
	        AND node.lft BETWEEN sub_parent.lft AND sub_parent.rgt
	        AND sub_parent.Category_ID = sub_tree.Category_ID
	/*AND node.Business_Id  ='$Business_ID'
	AND parent.Business_ID='$Business_ID'*/
	GROUP BY node.Category_ID
	ORDER BY node.lft");
            $query->execute();
            $result1 = $query->fetchAll(PDO::FETCH_ASSOC);
            if(!empty($result1)){
                for($i=0;$i<count($result1);$i++)
                    $record2[] = $result1[$i]['cat'];
            }
            $record22 = implode(',',$record2);

            $query = $this->pdo->prepare("select count(1) as cnt
				from Article_Master,Store_Listing,Article_Category
				where Article_Master.Article_No=Store_Listing.Article_No
	                        AND Store_Listing.Article_No = Article_Category.Article_No
	                        AND Article_Category.Article_No = Article_Master.Article_No
				AND Store_Listing.`Store_No` = '$Store_No'
				AND Article_Category.Category_ID in($record22) AND Is_Article_In_Catalog('$Store_No','$CityCode',Store_Listing.Article_No) >0 AND Article_Master.Brand_ID=IFNULL($BrandNo,Article_Master.Brand_ID) AND Article_Master.Status='A' AND Store_Listing.Status = 'A' AND Article_Category.Status='A' ORDER BY Article_Master.Article_Desc, Article_Master.Approx_Weight ASC");
            $query->execute();
            $resultalla = $query->fetch(PDO::FETCH_ASSOC);
            $count_main = 0;
            if (!empty($resultalla)){
                // $datacount=mysqli_fetch_assoc($resultalla);
                $count_main = $resultalla['cnt'];//product count from the loop
            }
            $max_page_no = 0;
            if($count_main > 0){
                $max_page_no = ceil($count_main/10);
            }

            $cat_array = array();
            $query = $this->pdo->prepare("select Article_Master.Article_Desc,REPLACE( Article_Master.Article_Desc, '\\\', '' ) as descp,
			Article_Category.Category_ID as cat, Article_Master.Brand_ID as brand, Article_Master.Article_No as no, Article_Master.Valume as volume,
			Article_Master.Unit as unit,Article_Master.Image_Url as img, Article_Master.`Large_Image_Url` as large_img, Store_Listing.Unit_Price as price,
			Store_Listing.Offer_Price as offer, Store_Listing.Out_Of_Stock,
			Article_Master.Article_Short_Desc AS short_desc,
			Article_Master.Case_Size AS case_size,
			Article_Master.Tech_Spec AS tech_spec,
			Article_Master.Product_PDF AS product_pdf,
			Article_Master.Product_Type AS product_type,
			Article_Master.Composition AS composition,
			Store_Listing.Unit_Rate as unit_rate,
			Store_Listing.Offer_Rate as offer_rate,
			Article_Master.GST as gst,
			Article_Master.V_Mfg as make,
			Article_Master.V_Mfg_Month_Year as year,
			Article_Master.V_Model as model,
			Article_Master.OEM_Part_No as oemno,
			Get_Brand_Name(Article_Master.Brand_ID) as brandname,
			Get_Brand_Store(Article_Master.Article_No,'$Store_No') as split_store_no
			from Article_Master,Article_Category,Store_Listing
			where Article_Master.Article_No=Store_Listing.Article_No
	                       AND Store_Listing.Article_No=Article_Category.Article_No
	                       AND Article_Master.Article_No=Article_Category.Article_No
			AND Store_Listing.`Store_No` = '$Store_No'
			AND Article_Category.Category_ID in($record22)
			AND Is_Article_In_Catalog('$Store_No','$CityCode',Store_Listing.Article_No) >0
			AND   Article_Master.Brand_ID=IFNULL($BrandNo,Article_Master.Brand_ID) AND Article_Master.Status='A' AND Store_Listing.Status = 'A' AND Article_Category.Status='A' ORDER BY Article_Master.Article_Desc, Article_Master.Approx_Weight ASC limit ".$start.",".$limit."");
            $query->execute();
            $resultall = $query->fetchAll(PDO::FETCH_ASSOC);
            $allArticleNo 	= array();
            $articleData 	= array();
            $articleNo 		= "";
            if(!empty($resultall)){
                for($i=0; $i<count($resultall);$i++)
                {
                    // while($allArticleNoData = mysqli_fetch_assoc($resultall)){
                    array_push($articleData, $resultall[$i]);
                    array_push($allArticleNo, $resultall[$i]['no']);
                }
                $articleNo = implode("," , $allArticleNo);

                //For check the slabs data
                $queryAllArticleSlab = $this->pdo->prepare("SELECT
						Article_No,
						Min_Qty,
						Max_Qty,
						SK_Offer_Price,
						Offer_From,
						Offer_To
					FROM Article_Offers
					WHERE Article_No =$articleNo AND Status = 'A' AND Supplier_No = '$Store_No' ORDER BY Min_Qty ASC)");
                $queryAllArticleSlab->execute();
                $resultAllArticleSlab = $query->fetch(PDO::FETCH_ASSOC);
                $recordsAllArticleSlab 		= array();
                if(!empty($resultAllArticleSlab)){
                    // while($dataAllArticleSlab 	= mysqli_fetch_assoc($resultAllArticleSlab))
                    // {
                    array_push($recordsAllArticleSlab, $resultAllArticleSlab);
                    // }
                }
            }
            $slabs 	= array();
            $k		= 0;
            $s_array= array();

            $queryPricing = $this->pdo->prepare("Select Config_Value from Business_Config_Master
					where Business_Id = '$business_no'
					and   Config_Attribute='PRICING'
					and   Status='A'");
            $queryPricing->execute();
            // $query->debugDumpParams();
            $resultPricing = $queryPricing->fetch(PDO::FETCH_ASSOC);
            $pricingMode ='DECENTRALIZED';
            if(!empty($resultPricing)){
                $pricingMode   = $resultPricing['Config_Value'];
            }

            foreach($articleData as $row1) {


                $articleNo = 'article_'.$row1['no'];
                // if (array_in($row1['no'],$articleForCity))  //Branch <mee-dev-14>
                // {                                          //Branch mee-dev-14 process the articles only if it is eligible for current selected city
                if($languageType == '' OR $languageType == 'english'){
                    $s_array[$k]['desc'] 	= $row1['descp'];
                }else{
                    $s_array[$k]['desc'] 	= $lang[$articleNo] ?? $row1['descp'];

                }

                $volume 					= floatval($row1['volume']);
                $s_array[$k]['cat']			= $row1['cat'];
                //$s_array[$k]['desc']		= $row1['descp'];
                $s_array[$k]['brand']		= $row1['brand'];
                $s_array[$k]['no']			= $row1['no'];
                $s_array[$k]['volume']		= (string)$volume;
                $s_array[$k]['unit']		= $row1['unit'];
                $s_array[$k]['img']			= $row1['img'];
                $s_array[$k]['large_img']	= $row1['large_img'];
                // $s_array[$k]['price']		= $row1['price'];
                $s_array[$k]['offer']		= $row1['offer'];
                $s_array[$k]['out_of_stock']= intval($row1['Out_Of_Stock']);

                $s_array[$k]['short_desc']	= $row1['short_desc'];
                $s_array[$k]['case_size']	= $row1['case_size'];
                $s_array[$k]['tech_spec']	= $row1['tech_spec'];
                $s_array[$k]['product_pdf']	= $row1['product_pdf'];
                $s_array[$k]['product_type']= $row1['product_type'];
                $s_array[$k]['composition']	= $row1['composition'];
                // $s_array[$k]['unit_rate']	= $row1['unit_rate'];
                $s_array[$k]['offer_rate']	= $row1['offer_rate'];
                $s_array[$k]['gst']			= $row1['gst'];
                $s_array[$k]['make']        = $row1['make'];
                $s_array[$k]['year']        = $row1['year'];
                $s_array[$k]['model']       = $row1['model'];
                $s_array[$k]['oemno']       = $row1['oemno'];
                $s_array[$k]['brandname']   = $row1['brandname'];
                $s_array[$k]['split_store_no']   = $row1['split_store_no'];

                $s_array[$k]['quantity']="";
                if($myflag!="0"){
                    for($ii=0;$ii<sizeof($saved_cart);$ii++){
                        if($saved_cart[$ii][0]['Article_No']==$row1['no'] and $saved_cart[$ii][0]['Store_No']==$Store_No){
                            $s_array[$k]['quantity']=$saved_cart[$ii][0]['quantity'];

                            break;
                        }
                    }
                }

                //Call Procedure to get Article Price -apply all schemes whichever applicable
                $currarticle= $row1['no'];
                //Procedure parameters in order - Article no,store no,customer no,qty and casesize
                $articleqty = $s_array[$k]['quantity'];
                if ($articleqty =='') {
                    $articleqty = 1; //by default qty should be 1
                }

                if ($pricingMode =='CENTRALIZED')
                    $queryArticleSchemes=$this->pdo->prepare("CALL Get_Cust_Article_Price($currarticle,$Store_No,$cust_no,$business_no,$articleqty)");
                else
                    $queryArticleSchemes=$this->pdo->prepare("CALL Get_Cust_Article_Price($currarticle,$Store_No,$cust_no,0,$articleqty)");
                $queryArticleSchemes->execute();
                $resultArticleSchemes = $queryArticleSchemes->fetch(PDO::FETCH_ASSOC);
                $s_array[$k]['scheme_price']= "0";
                $s_array[$k]['scheme_id']   = "0";
                $s_array[$k]['scheme_name'] = "";
                if (!empty($resultArticleSchemes)) {
                    // $dataArticleSchemes = mysqli_fetch_assoc($resultArticleSchemes);

                    $s_array[$k]['offer']		= $resultArticleSchemes['Offer_Price'];
                    $s_array[$k]['offer_rate']	= $resultArticleSchemes['Offer_Rate'];
                    $s_array[$k]['scheme_price']= $resultArticleSchemes['Scheme_Price'];
                    $s_array[$k]['scheme_id']   = $resultArticleSchemes['Scheme_ID'];
                    $s_array[$k]['scheme_name'] = $resultArticleSchemes['Scheme_Name'];
                    $s_array[$k]['unit_rate']	= $resultArticleSchemes['Unit_Rate'];
                    $s_array[$k]['price']	    = $resultArticleSchemes['Unit_Price'];
                }
                $index 	= 0;
                $slabs 	= array();
                $minQty = array();
                $slabsFlag = "N";
                foreach($recordsAllArticleSlab as $value){
                    if($row1['no'] == $value['Article_No']){
                        unset($value['Article_No']);

                        array_push($minQty, $value['Min_Qty']);

                        array_push($slabs, $value);
                        $index = $index+1;
                        $slabsFlag = "Y";
                    }

                }

                $maxQty = "9999";
                $defaultSlab = array();
                if($slabsFlag == 'N' OR min($minQty) >= 2) {

                    if((COUNT($minQty) > 0) && (min($minQty) >= 2)){
                        $maxQty = min($minQty) - 1;
                    }
                    $defaultSlab['Article_No'] 		= $row1['no'];
                    $defaultSlab['Min_Qty'] 		= "1";
                    $defaultSlab['Max_Qty'] 		= (string)$maxQty;
                    //$defaultSlab['Supplier_Price'] 	= $row1['price'];
                    $defaultSlab['SK_Offer_Price'] 	= $row1['offer'];
                    $defaultSlab['Offer_From'] 		= "";
                    $defaultSlab['Offer_To'] 		= "";
                }

                $s_array[$k]['slabs_flag']		= $slabsFlag;

                if(COUNT($defaultSlab)>0){
                    //$s_array[$k]['slabs'][0] = $defaultSlab;
                    array_unshift($slabs,$defaultSlab);
                }
                if(COUNT($slabs)>0){
                    //foreach ($slabs as $slabsArr) {
                    //    array_push($s_array[$k]['slabs'], $slabsArr);
                    //}
                    $s_array[$k]['slabs']=$slabs;
                }

                // All category article slabs
                $article = $row1['no'];
                $more_images=array();
                $queryMoreArticleImages = $this->pdo->prepare("SELECT
							Large_Image_Url
							FROM Article_More_Images
							WHERE Article_No = '$article' ORDER BY Id ");
                $queryMoreArticleImages->execute();
                //$recordsAllArticleImages = array();
                $resultAllArticleImages = $queryMoreArticleImages->fetch(PDO::FETCH_ASSOC);
                if (!empty($resultAllArticleImages)) {
                    array_push($more_images,$resultAllArticleImages);
                }
                $s_array[$k]['more_images'] = $more_images;

                //End Images
                //Article Where Use - Added by Meenal Barve 30th November 2018
                //$article= $row1['no'];
                $where_use=array();
                $queryWhereUse = $this->pdo->prepare("SELECT
									V_Mfg as make,
									V_Mfg_Month_Year as year,
									V_Model as model
									FROM Article_Where_Use
									WHERE Article_No = '$article' ORDER BY V_Mfg,V_Model,V_Mfg_Month_Year");
                $queryWhereUse->execute();
                $resultAllWhereUse = $queryWhereUse->fetch(PDO::FETCH_ASSOC);
                //$recordsAllArticleImages = array();
                if (!empty($resultAllWhereUse)) {
                    array_push($where_use,$resultAllWhereUse);
                }

                $s_array[$k]['where_use'] = $where_use;
                $k=$k+1;
            }

            $cat_array['cat']=$Merch_Cat;
            $cat_array['products']=$s_array;
            $cat_array['pages']=$max_page_no;
            $cat_array['product_count'] = $count_main;


            array_push($article_result, $cat_array);


            json_encode($article_result, JSON_UNESCAPED_UNICODE);

            if(!empty($article_result))
            {
                $status = true;
                $data = $article_result;
                $msg = 'Success';
            }
            else
            {
                $status = false;
                $msg = 'Data is not available';
            }
            return get_response($msg, $status, $data);
        }catch (PDOException $e) {
            $status = false;
            $data = $e->getMessage();
            return get_response("Something went wrong", $status, $data);
        }
    }

    public function get_articles_for_cat_level(Request $request){
        $logTxtST = getDateTimeWithMS();
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);

        $status = true;
        $record 	= array();
        $cust_no 	= 0;
        $Merch_Cat 	 = $Merch_Cat;
        $Store_No 	 = $Store_No;
        $Business_ID = $Business_ID;
        $BrandNo     = NULL;
        $CityCode    = $City_Code;
        try{
            if (isset($Brand_No))  {

                if ($Brand_No !="")
                    $BrandNo = $Brand_No;
                else
                    $BrandNo = NULL;
            }

            if (isset($Cust_No)) {
                $cust_no = $Cust_No;
            }

            $Business_ID 	= 0;
            if (isset($Business_ID)) {
                $business_no = $Business_ID;
            }

            $languageType = $_REQUEST['language_type'] ?? '';

            if($languageType != ''){
                include_once(LANGUAGE_PATH.$languageType.'/article_lang.php');
            }


            $getCustType = getCustType($this->pdo,$cust_no, $Store_No);
            $myflag = 0;

            //logMeIn('get_articles_for_cat_level', [ 'select * from User_Cart Where Cust_No = '.$cust_no]);

            $query = $this->pdo->prepare("select * from User_Cart Where Cust_No='$cust_no'");
            $query->execute();

            $resultcart = $query->fetch(PDO::FETCH_ASSOC);

            //logMeIn('get_articles_for_cat_level', [ 'fetch User_Cart = ', json_encode($resultcart) ]);

            if (!empty($resultcart) > 0) {
                $myflag = 1;
                $row = $resultcart;
                $saved_cart = $row['Cart_Data'];
                $saved_cart = json_decode($saved_cart, true);
            }

            $lmt = 100;
            $page = $Page;
            if ($page == "0") {
                $start = 0;
                $limit = $lmt; //for Pagination 10 per page
            } else {
                $start = $page * $lmt;
                $limit = $lmt; //for Pagination 10 per page
            }
            $article_result = array();

            $logTxt[] = 'Page='.$page;
            $logTxt[] = 'PageSize='.$limit;

            /*$query1=$this->pdo->prepare("SELECT node.Category_ID as cat,
            node.Cat_Desc as 'Desc',
            (COUNT(parent.Category_ID) - (sub_tree.depth + 1)) AS depth,
            Is_Leaf(node.Category_ID) as Is_Leaf_Node
            FROM Nested_Category AS node,
                    Nested_Category AS parent,
                    Nested_Category AS sub_parent,
                    (
                            SELECT node.Category_ID, (COUNT(parent.Category_ID) - 1) AS depth
                            FROM Nested_Category AS node,
                                    Nested_Category AS parent
                            WHERE node.lft BETWEEN parent.lft AND parent.rgt
                                    AND node.Category_ID   ='$Merch_Cat'
                            GROUP BY node.Category_ID
                            ORDER BY node.lft
                    )AS sub_tree
            WHERE node.lft BETWEEN parent.lft AND parent.rgt
                    AND node.lft BETWEEN sub_parent.lft AND sub_parent.rgt
                    AND sub_parent.Category_ID = sub_tree.Category_ID
            GROUP BY node.Category_ID
            ORDER BY node.lft");
            $query1->execute();
            $result1 = $query1->fetchAll(PDO::FETCH_ASSOC);

            if(!empty($result1))
            {
                $count_cat = count($result1);
                foreach ($result1 as $row2) {
                    $record2[] = $row2['cat'];
                }
            }*/
            //$allcat = implode(',',$record2);
            $wherecatlevel='';
            $catcollevel='';
            //logMeIn('get_articles_for_cat_level', [ "Select Find_Level($Merch_Cat) as lvl"]);
            $getlevelsql= $this->pdo->prepare("Select Find_Level($Merch_Cat) as lvl");
            $getlevelsql->execute();

            $resultLevel = $getlevelsql->fetch(PDO::FETCH_ASSOC);
            //logMeIn('get_articles_for_cat_level', [ "fetch Find = ", json_encode($resultLevel)]);

            if (!empty($resultLevel)){
                $row = $resultLevel;
                $level=$row['lvl'];

                $wherecatlevel =' AND Article_Category.Level_'.$level.' = '.$Merch_Cat.' ';

            }
            else{
                $wherecatlevel =' AND Article_Category.Level_0 = '.$Merch_Cat.' ';

            }

            //logMeIn('get_articles_for_cat_level', [ "select Article_Master to get count= "]);
            $query = $this->pdo->prepare("select count(1) as cnt
				from Article_Master
	            INNER JOIN Store_Listing on Store_Listing.Article_No= Article_Master.Article_No

				INNER JOIN Article_Category  on Article_Category.Article_No = Article_Master.Article_No AND Store_Listing.Article_No=Article_Category.Article_No
				INNER JOIN Store_Cust_Article_Price SCAP on SCAP.Article_No = Article_Master.Article_No
					AND SCAP.Store_No = '$Store_No'
					AND (SCAP.Cust_No = 0
					AND SCAP.Cust_Type = '$getCustType')
				LEFT JOIN Store_City_Article SC on SC.Store_No = Store_Listing.Store_No AND Store_Listing.Article_No = SC.Article_No and SC.City_Code = '$CityCode'
				where  Store_Listing.`Store_No` = ?
				$wherecatlevel
	            AND    Article_Category.Status='A'
	            and    ifnull(SC.Show_Flag,1)>0
	            and    SCAP.Offer_Price>0
	            AND Store_Listing.Status = 'A'
	            and Article_Master.Status='A'
	            	            AND   Article_Master.Brand_ID=IFNULL(?,Article_Master.Brand_ID)
				ORDER BY Article_Master.Article_Desc, Article_Master.Approx_Weight ASC");

            $query->execute([$Store_No,$BrandNo]);

            // $resultalla=mysqli_query($con,$query);
            //$query->debugDumpParams();
            $resultalla = $query->fetch(PDO::FETCH_ASSOC);
            //logMeIn('get_articles_for_cat_level', [ "fetch Article_Master to get count= ", json_encode($resultalla)]);
            // print_r($resultalla);die();
            $count_main=0;
            if (!empty($resultalla)){
                $datacount=$resultalla;
                $count_main=$datacount['cnt'];//product count from the loop
            }
            //logMeIn('get_articles_for_cat_level', [ "fetch Article_Master count_main= ", $count_main]);
            $max_page_no=0;
            if($count_main>0){
                $max_page_no=ceil($count_main/10);
            }

            //logMeIn('get_articles_for_cat_level', [ "fetch Article_Master max_page_no= ", $max_page_no]);
            $cat_array=array();

            $query=$this->pdo->prepare("select Article_Master.Article_Desc,REPLACE( Article_Master.Article_Desc, '\\\', '' ) as descp,
			    Article_Category.Category_ID as cat, Article_Master.Brand_ID as brand, Article_Master.Article_No as no, Article_Master.Valume as volume,
				Article_Master.Unit as unit,Article_Master.Image_Url as img, Article_Master.`Large_Image_Url` as large_img,
				Store_Listing.Out_Of_Stock,
				Article_Master.Article_Short_Desc AS short_desc,
				Article_Master.Case_Size AS case_size,
				Article_Master.Tech_Spec AS tech_spec,
				Article_Master.Product_PDF AS product_pdf,
				Article_Master.Product_Type AS product_type,
				Article_Master.Composition AS composition,
				Article_Master.GST as gst,
				Article_Master.Dietary_Code as dietary_code,
				Article_Master.V_Mfg as make,
				Article_Master.V_Mfg_Month_Year as year,
				Article_Master.V_Model as model,
				Article_Master.OEM_Part_No as oemno,
				Article_Master.Display_Seq_Text,
				Article_Master.Display_Seq_No,
				Get_Brand_Name(Article_Master.Brand_ID) as brandname,
				SC.Split_Store_No as split_store_no,
				Cust_Type ,
				SCAP.Offer_Price ,
				SCAP.Offer_Rate ,
				SCAP.Unit_Price ,
				SCAP.Unit_Rate ,
				SCAP.Scheme_Price ,
				Scheme_ID ,
				Cust_Margin ,
				Scheme_Name
				from Article_Master
				INNER JOIN Store_Listing on Store_Listing.Article_No= Article_Master.Article_No
				INNER JOIN Article_Category  on Article_Category.Article_No = Article_Master.Article_No AND Store_Listing.Article_No=Article_Category.Article_No
				INNER JOIN Store_Cust_Article_Price SCAP on SCAP.Article_No = Article_Master.Article_No
					AND SCAP.Store_No = '$Store_No'
					AND (SCAP.Cust_No = 0
					AND SCAP.Cust_Type = '$getCustType')
				LEFT OUTER JOIN Store_City_Article SC on SC.Store_No = Store_Listing.Store_No AND Store_Listing.Article_No = SC.Article_No and SC.City_Code = '$CityCode'
				where  Store_Listing.`Store_No` = ?
				$wherecatlevel
	            AND    Article_Category.Status='A'
	            and    ifnull(SC.Show_Flag,1)>0
	            and    SCAP.Offer_Price>0
	            AND   Article_Master.Brand_ID=IFNULL(?,Article_Master.Brand_ID) AND Article_Master.Status='A' AND Store_Listing.Status = 'A' AND Article_Category.Status='A' ORDER BY  	Article_Master.Display_Seq_Text, Article_Master.Display_Seq_No,Article_Master.Article_Desc,
				Article_Master.Approx_Weight ASC limit ".$start.",".$limit."");

            $query->execute([$Store_No,$BrandNo]);

            $resultall = $query->fetchAll(PDO::FETCH_ASSOC);

            $allArticleNo 	= array();
            $articleData 	= array();
            $articleNo 		= "";
            // $query->debugDumpParams();die;
            if(!empty($resultall))
            {
                foreach ($resultall as $allArticleNoData) {
                    array_push($articleData, $allArticleNoData);
                    array_push($allArticleNo, $allArticleNoData['no']);
                }
                $articleNo = implode("," , $allArticleNo);

                $queryAllArticleSlab = $this->pdo->prepare("SELECT
						Article_No,
						Min_Qty,
						Max_Qty,
						-- Supplier_Price,
						SK_Offer_Price,
						Offer_From,
						Offer_To

					FROM Article_Offers

					WHERE Article_No =$articleNo AND Status = 'A' AND Supplier_No = '$Store_No' ORDER BY Min_Qty ASC");
                $queryAllArticleSlab->execute();
                $resultAllArticleSlab = $queryAllArticleSlab->fetchAll(PDO::FETCH_ASSOC);
                // $resultAllArticleSlab 		= mysqli_query($con,$queryAllArticleSlab);
                $recordsAllArticleSlab 		= array();
                if(!empty($resultAllArticleSlab)){
                    foreach($resultAllArticleSlab as $dataAllArticleSlab)
                    {
                        array_push($recordsAllArticleSlab, $dataAllArticleSlab);
                    }
                }
            }

            $slabs 	= array();
            $k		= 0;
            $s_array= array();
            //      $queryPricing = "Select Config_Value from Business_Config_Master
            // 			where Business_Id = '$business_no'
            // 			and   Config_Attribute='PRICING'
            // 			and   Status='A';";
            //      $resultPricing    = mysqli_query($con,$queryPricing);
            //      $pricingMode ='DECENTRALIZED';
            //      if(mysqli_num_rows($resultPricing) > 0){
            //           $pricingResult = mysqli_fetch_assoc($resultPricing);
            //           $pricingMode   = $pricingResult['Config_Value'];

            //      }
            //      // $s_array = array();
            //   //mmb-android-pricing
            //logMeIn('get_articles_for_cat_level', [ "foreach articleData= ", json_encode($articleData)]);
            foreach($articleData as $row1) {
                //print_r($row1);

                $articleNo = 'article_'.$row1['no'];
                // if (array_in($row1['no'],$articleForCity))  //Branch <mee-dev-14>
                // {                                          //Branch mee-dev-14 process the articles only if it is eligible for current selected city
                if($languageType == '' OR $languageType == 'english'){
                    $s_array[$k]['desc'] 	= $row1['descp'];
                }else{
                    $s_array[$k]['desc'] 	= $lang[$articleNo] ?? $row1['descp'];

                }

                $volume 					= floatval($row1['volume']);
                $s_array[$k]['cat']			= $row1['cat'];
                $s_array[$k]['display_seq_text']		= $row1['Display_Seq_Text'];
                $s_array[$k]['display_seq_no']		= $row1['Display_Seq_No'];
                $s_array[$k]['brand']		= $row1['brand'];
                $s_array[$k]['no']			= $row1['no'];
                $s_array[$k]['volume']		= (string)$volume;
                $s_array[$k]['unit']		= $row1['unit'];
                $s_array[$k]['img']			= $row1['img'];
                $s_array[$k]['large_img']	= $row1['large_img'];
                //$s_array[$k]['price']		= $row1['price']; //mmb-android-pricing
                //$s_array[$k]['offer']		= $row1['offer']; //mmb-android-pricing
                $s_array[$k]['out_of_stock']= intval($row1['Out_Of_Stock']);

                $s_array[$k]['short_desc']	= $row1['short_desc'];
                $s_array[$k]['case_size']	= $row1['case_size'];
                $s_array[$k]['tech_spec']	= $row1['tech_spec'];
                $s_array[$k]['product_pdf']	= $row1['product_pdf'];
                $s_array[$k]['product_type']= $row1['product_type'];
                $s_array[$k]['composition']	= $row1['composition'];
                //$s_array[$k]['unit_rate']	= $row1['unit_rate']; //mmb-android-pricing
                //$s_array[$k]['offer_rate']	= $row1['offer_rate'];   //mmb-android-pricing
                $s_array[$k]['gst']			= $row1['gst'];
                $s_array[$k]['dietary_code']			= $row1['dietary_code']; // added by swanand
                $s_array[$k]['make']        = $row1['make'];
                $s_array[$k]['year']        = $row1['year'];
                $s_array[$k]['model']       = $row1['model'];
                $s_array[$k]['oemno']       = $row1['oemno'];
                $s_array[$k]['brandname']   = $row1['brandname'];
                $s_array[$k]['split_store_no']   = $row1['split_store_no'];

                $s_array[$k]['quantity']="";
                if($myflag!="0"){
                    for($ii=0;$ii<sizeof($saved_cart);$ii++){
                        if($saved_cart[$ii][0]['Article_No']==$row1['no'] and $saved_cart[$ii][0]['Store_No']==$Store_No){
                            $s_array[$k]['quantity']=$saved_cart[$ii][0]['quantity'];

                            break;
                        }
                    }
                }

                //Call Procedure to get Article Price -apply all schemes whichever applicable
                $currarticle= $row1['no'];
                //Procedure parameters in order - Article no,store no,customer no,qty and casesize
                $articleqty = $s_array[$k]['quantity'];
                if ($articleqty =='') {
                    $articleqty = 1; //by default qty should be 1
                }

                $s_array[$k]['offer']		= $row1['Offer_Price'];
                $s_array[$k]['offer_rate']	= $row1['Offer_Rate'];
                $s_array[$k]['scheme_price']= $row1['Scheme_Price'];
                $s_array[$k]['scheme_id']   = $row1['Scheme_ID'];
                $s_array[$k]['scheme_name'] = $row1['Scheme_Name'];
                $s_array[$k]['unit_rate']	= $row1['Unit_Rate'];
                $s_array[$k]['price']	    = $row1['Unit_Price'];
                $s_array[$k]['cust_type']   = $row1['Cust_Type'];      //pricing
                $s_array[$k]['cust_margin'] = $row1['Cust_Margin'];   //pricing


                $queryArticleSchemes = $this->pdo->prepare("SELECT Store_No, Business_No, Cust_No, Cust_Type, Offer_Price, Offer_Rate, Unit_Price, Unit_Rate, Scheme_Price, Scheme_ID, Cust_Margin, Scheme_Name
					FROM Store_Cust_Article_Price SCAP
					WHERE SCAP.Article_No = '$currarticle'
					AND SCAP.Store_No = '$Store_No'
					AND  SCAP.Cust_No = '$cust_no'
					ORDER BY SCAP.Cust_No DESC");

                $queryArticleSchemes->execute();

                // print_r($queryArticleSchemes);
                // die();
                $resultArticleSchemes  = $queryArticleSchemes->fetch(PDO::FETCH_ASSOC);

                if (!empty($resultArticleSchemes)) {
                    $dataArticleSchemes = $resultArticleSchemes;


                    $s_array[$k]['offer']		= $dataArticleSchemes['Offer_Price'];
                    $s_array[$k]['offer_rate']	= $dataArticleSchemes['Offer_Rate'];
                    $s_array[$k]['scheme_price']= $dataArticleSchemes['Scheme_Price'];
                    $s_array[$k]['scheme_id']   = $dataArticleSchemes['Scheme_ID'];
                    $s_array[$k]['scheme_name'] = $dataArticleSchemes['Scheme_Name'];
                    //mmb-android-pricing
                    $s_array[$k]['unit_rate']	= $dataArticleSchemes['Unit_Rate'];
                    $s_array[$k]['price']	    = $dataArticleSchemes['Unit_Price'];
                    //$s_array[$k]['cust_type']   = $dataArticleSchemes['Cust_Type'];      //pricing
                    $s_array[$k]['cust_margin'] = $dataArticleSchemes['Cust_Margin'];  //pricing
                    //mmb-android-pricing
                }




                // All category article slabs

                $index 	= 0;
                $slabs 	= array();
                $minQty = array();
                $slabsFlag = "N";
                foreach($recordsAllArticleSlab as $value){
                    if($row1['no'] == $value['Article_No']){
                        unset($value['Article_No']);

                        array_push($minQty, $value['Min_Qty']);

                        array_push($slabs, $value);
                        $index = $index+1;
                        $slabsFlag = "Y";
                    }

                }

                $maxQty = "9999";
                $defaultSlab = array();
                if($slabsFlag == 'N' OR min($minQty) >= 2) {

                    if((COUNT($minQty) > 0) && (min($minQty) >= 2)){
                        $maxQty = min($minQty) - 1;
                    }
                    $defaultSlab['Article_No'] 		= $row1['no'];
                    $defaultSlab['Min_Qty'] 		= "1";
                    $defaultSlab['Max_Qty'] 		= (string)$maxQty;
                    //$defaultSlab['Supplier_Price'] 	= $row1['price'];
                    $defaultSlab['SK_Offer_Price'] 	= $row1['offer'];
                    $defaultSlab['Offer_From'] 		= "";
                    $defaultSlab['Offer_To'] 		= "";
                }

                $s_array[$k]['slabs_flag']		= $slabsFlag;

                if(COUNT($defaultSlab)>0){
                    //$s_array[$k]['slabs'][0] = $defaultSlab;
                    array_unshift($slabs,$defaultSlab);
                }
                if(COUNT($slabs)>0){
                    //foreach ($slabs as $slabsArr) {
                    //    array_push($s_array[$k]['slabs'], $slabsArr);
                    //}
                    $s_array[$k]['slabs']=$slabs;
                }

                // All category article slabs
                $article = $row1['no'];
                $more_images=array();
                //Article More Images - Added by Meenal Barve 16th August 2018
                $queryMoreArticleImages = $this->pdo->prepare("SELECT
							Large_Image_Url
							FROM Article_More_Images
							WHERE Article_No = '$article' ORDER BY Id ");
                $queryMoreArticleImages->execute();
                $resultAllArticleImages  = $queryMoreArticleImages->fetchAll(PDO::FETCH_ASSOC);
                // $resultAllArticleImages  = mysqli_query($con,$queryMoreArticleImages);
                //$recordsAllArticleImages = array();
                if (!empty($resultAllArticleImages)) {
                    foreach ($resultAllArticleImages as $dataAllArticleImages)
                    {
                        array_push($more_images,$dataAllArticleImages);
                    }
                }


                $s_array[$k]['more_images'] = $more_images;

                //End Images
                //Article Where Use - Added by Meenal Barve 30th November 2018
                //$article= $row1['no'];
                $where_use=array();
                $queryWhereUse = $this->pdo->prepare("SELECT
									V_Mfg as make,
									V_Mfg_Month_Year as year,
									V_Model as model
									FROM Article_Where_Use
									WHERE Article_No = '$article' ORDER BY V_Mfg,V_Model,V_Mfg_Month_Year");
                $queryWhereUse->execute();
                $resultAllWhereUse  = $queryWhereUse->fetchAll(PDO::FETCH_ASSOC);

                // $resultAllWhereUse  = mysqli_query($con,$queryWhereUse);
                //$recordsAllArticleImages = array();
                if (!empty($resultAllWhereUse)) {
                    foreach ($resultAllWhereUse as $dataAllWhereUse )
                    {
                        array_push($where_use,$dataAllWhereUse);
                    }
                }

                $s_array[$k]['where_use'] = $where_use;

                $k=$k+1;

            }
            $cat_array['cat']=$Merch_Cat;
            $cat_array['products']=$s_array;
            $cat_array['pages']=$max_page_no;
            $cat_array['product_count'] = $count_main;

            $msg="Success";
            $logTxtET = getDateTimeWithMS();
            $logTxt[] = '  EndTime='.$logTxtET;
            $logTxt[] = 'StartTime='.$logTxtST;
            //$logTxt[] = getDateTimeDiffWithMS($logTxtET, $logTxtST);
            logMeIn('get_articles_for_cat_level', print_r($logTxt, true));
            return get_response($msg, $status, $cat_array);
        }
        catch (PDOException $e)
        {
            $status = false;
            $data = $e->getMessage();
            return get_response("Something went wrong", $status, $data);
        }
    }

}
