<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;
use PDOException;

class BusinessController extends Controller
{
    public function get_Business_Config_Data(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);

        $param_array = array();

        if (isset($Config_Parameter))  {
            $param_array[':config_param'] = $Config_Parameter;
        }

        //Ignore Business ID for now
        try {
            $stmt = $this->pdo->prepare("SELECT Config_Attribute as ConfigKey,Config_Value as ConfigValue,Config_Value_Code as ConfigCode
        FROM  Business_Config_Master
        where Config_Attribute=:config_param");

            $stmt->execute($param_array);
            //$stmt->debugDumpParams();
            $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);

            if (!empty($arr)) {

                //  $data = $arr;

                foreach($arr as $key=>$details){
                    $config_values[] = $details['ConfigValue'];
                    //    $config_values2[] = $details['ConfigCode'];
                }
                $msg = 'Success';
                $data['Values']=$config_values;
                //$data['ValuesID'] = $config_values2;
            } else {
                $msg = 'Config data not available';
                $status = false;
            }
        } catch (PDOException $e) {
            $status = false;
            $data = $e->getMessage();
            $msg = "Something went wrong";
        }

        return get_response($msg, $status, $data);
    }
}
