<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;
use PDOException;

class CartController extends Controller
{
    public function save_cart(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);

        $json_input_decode = array();

        $json_input_decode[':cart_data'] = $cart_data;

        $cust_no = $cart_data['cust_no'];
        try{
            if(isset($cart_data['stores']) && !empty($cart_data['stores'])){
                $final_array=array();
                for($i=0;$i<sizeof($cart_data['stores']);$i++){

                    $StoreNo=$cart_data['stores'][$i]['store_no'];

                    for($j=0;$j<sizeof($cart_data['stores'][$i]['items']);$j++)
                    {
                        $ArticleNo=$cart_data['stores'][$i]['items'][$j]['no'];
                        $quantity= $cart_data['stores'][$i]['items'][$j]['quantity'];

                        $row[0]['Article_No']=$ArticleNo;
                        $row[0]['Store_No']=$StoreNo;
                        $row[0]['quantity']=$quantity;
                        array_push($final_array, $row);

                    }
                    $data = updateCartData($this->pdo,$cust_no, $StoreNo, $final_array,true);
                }

            }
            else{
                $final_array=array();
                $data = updateCartData($this->pdo,$cust_no, null, $final_array,true);
            }
            $msg = "Cart data updated successfully";
        }
        catch (PDOException $e) {
            $status = false;
            $data = $e->getMessage();
            $msg = "Something went wrong";
        }
        return get_response($msg, $status, $data);
    }

    public function get_cart_data(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);

        try{
            $stmt = $this->pdo->prepare("select * from User_Cart where Cust_No='$Cust_No'");

            $stmt->execute();
            $arr = $stmt->fetch(PDO::FETCH_ASSOC);

            $cart=$arr['Cart_Data'];
            $array=json_decode($cart);

            $cart_array=array();
            $i=0;
            $cart_array['cust_no']=$Cust_No;
            $cart_array['stores']=array();
            $i=0;
            $business_no = $Business_ID? $Business_ID:''; //mmb-android-pricing

            //mmb-android-pricing
            $queryPricing = $this->pdo->prepare("Select Config_Value from Business_Config_Master
				where Business_Id = $business_no
				and   Config_Attribute='PRICING'
				and   Status='A'");
            $queryPricing->execute();
            $pricingMode ='DECENTRALIZED';
            $pricingResult = $queryPricing->fetch(PDO::FETCH_ASSOC);
            $pricingMode   = $pricingResult['Config_Value'];
            //mmb-android-pricing


            if(!empty($cart)){

                $store=array();
                $i=0;
                foreach($array as $value){
                    foreach($value as $newa){

                        $favouriteStoreNo = $newa->Store_No;

                        if(!empty($store_id)){
                            if($favouriteStoreNo == $store_id){
                                $store[$i]=$favouriteStoreNo; break;
                            }
                        }else{
                            $store[$i]=$favouriteStoreNo;
                        }
                        $i=$i+1;
                    }
                }

                $store=array_unique($store);

                foreach($store as $value){
                    $mystore=array();
                    $StoreNo=$value;
                    $getCustType = getCustType($this->pdo, $Cust_No, $StoreNo);
                    $mystore['store_no']=$StoreNo;
                    //array_push($cart_array['stores'][$i]['store_no'], $StoreNo);
                    $mystore['items']=array();
                    foreach($array as $value)
                    {
                        foreach($value as $new)
                        {
                            if($new->Store_No==$StoreNo)
                            {
                                $ArticleNo=$new->Article_No;
                                $Quantity=$new->quantity;

                                $stmt = $this->pdo->prepare("SELECT
					AM.`Article_No` as no,
					AM.`Valume` as vol,
					AM.`Unit` as unit,
					AM.`Merch_Cat` as cat,
					AM.`Image_Url` as image,
					AM.`Large_Image_Url` as large_img,
					AM.`Article_Desc` as descp,
					AM.`Brand_ID` as brand,
					SM.`Store_Name` as store_name,
					SM.`Min_Order_Amt` as min_order_amt,
					SM.`Min_Order_Amt_Without_Chrg` as min_order_amt_without_chrg,
					SM.`Delivery_Charge` as delivery_charge,
					-- SL.`Unit_Price` as unit_price,     //mmb-androidpricingfinal
					-- SL.`Offer_Price`  as offer_price,  //mmb-androidpricingfinal
					SL.`Out_Of_Stock` as outofstock,
					AM.Article_Short_Desc AS short_desc,
					AM.Case_Size AS case_size,
					AM.Tech_Spec AS tech_spec,
					AM.Product_PDF AS product_pdf,
					AM.Product_Type AS product_type,
					AM.Composition AS composition,
					-- SL.Unit_Rate as unit_rate,   //mmb-androidpricingfinal
					-- SL.Offer_Rate as offer_rate, //mmb-androidpricingfinal
					-- Get_GST_Rate_Article(AM.Article_No) as gst,
					AM.GST as gst,
					AM.Dietary_Code as dietary_code ,
					AM.V_Mfg as make,
					AM.V_Mfg_Month_Year as year,
					AM.V_Model as model,
					AM.OEM_Part_No as oemno,
					Get_Brand_Name(AM.Brand_ID) as brandname,
					SC.Split_Store_No as split_store_no,
				    Cust_Type as cust_type,
				    SCAP.Offer_Price as offer_price,
				    SCAP.Offer_Rate as offer_rate,
				    SCAP.Unit_Price as unit_price,
				    SCAP.Unit_Rate as unit_rate,
				    SCAP.Scheme_Price as scheme_price,
					Scheme_ID as scheme_id,
					Cust_Margin as cust_margin,
					Scheme_Name as scheme_name
					FROM `Article_Master` As `AM`
					INNER JOIN `Store_Listing` AS `SL` ON AM.`Article_No` = SL.`Article_No`
					 INNER JOIN Store_Cust_Article_Price SCAP on SCAP.Article_No = AM.Article_No
							AND SCAP.Store_No = '$StoreNo'
							AND (SCAP.Cust_No = 0
							AND SCAP.Cust_Type = '$getCustType')
					INNER JOIN `Store_Master` AS `SM` ON SL.`Store_No` = SM.`Store_No`
					LEFT OUTER JOIN Store_City_Article SC on SC.Store_No = SL.Store_No AND SL.Article_No = SC.Article_No and SC.City_Code = '$City_Code'
					WHERE AM.`Article_No` = '$ArticleNo' AND SL.`Store_No` = '$StoreNo' AND
					ifnull(SC.Show_Flag,1)>0 AND    SCAP.Offer_Price>0 AND
					AM.Status = 'A' AND SL.Status = 'A' AND SL.`Out_Of_Stock` = 0");

                                // $result=mysqli_query($con,$query);
                                // $row=mysqli_fetch_assoc($result);

                                $stmt->execute();
                                $arr = $stmt->fetch(PDO::FETCH_ASSOC);

                                if(in_array($ArticleNo, $arr)) {

                                    $arr['quantity']=$Quantity;

                                    $mystore['store_name']=$arr['store_name'];
                                    $mystore['min']=$arr['min_order_amt'];
                                    $mystore['min_free']=$arr['min_order_amt_without_chrg'];
                                    $mystore['charge']=$arr['delivery_charge'];

                                    $mystore['show_message']='';
                                    $mystore['message']='';

                                    $out_of_stock=intval($arr['outofstock']);
                                    $arr['out_of_stock']=$out_of_stock;
                                    $volume=floatval($arr['vol']);
                                    $arr['volume']=(string)$volume;

                                    unset($arr['vol']);
                                    unset($arr['store_name']);
                                    unset($arr['min_order_amt']);
                                    unset($arr['min_order_amt_without_chrg']);
                                    unset($arr['delivery_charge']);
                                    unset($arr['outofstock']);

                                    /* For check the slabs data */
                                    $articleNo = $arr['no'];
                                    $stmt1 = $this->pdo->prepare("SELECT
                              Article_No,
                              Min_Qty,
                              Max_Qty,
                              -- Supplier_Price,
                              SK_Offer_Price,
                              Offer_From,
                              Offer_To

                        FROM Article_Offers

                        WHERE Article_No = '$articleNo' AND Status = 'A' AND Supplier_No = '$StoreNo' ORDER BY Min_Qty ASC");

                                    $resultAllArticleSlab  = $stmt1->execute();
                                    $recordsAllArticle = array();
                                    $recordsAllArticle = $stmt1->fetch(PDO::FETCH_ASSOC);


                                    // if(sizeof($recordsAllArticle) > 0){
                                    //     while($dataAllArticleSlab     = $stmt1->fetch(PDO::FETCH_ASSOC))
                                    //     {
                                    //             array_push($recordsAllArticleRows, $dataAllArticleSlab);
                                    //     }
                                    // }
                                    $index      = 0;
                                    $slabs      = array();
                                    $minQty     = array();
                                    $slabsFlag  = "N";
                                    if(!empty($recordsAllArticle))
                                    {
                                        foreach($recordsAllArticle as $value){
                                            if($arr['no'] == $value['Article_No']){
                                                unset($value['Article_No']);

                                                array_push($minQty, $value['Min_Qty']);

                                                array_push($slabs, $value);
                                                $index = $index+1;
                                                $slabsFlag = "Y";
                                            }

                                        }
                                    }

                                    $maxQty = "9999";
                                    $defaultSlab = array();
                                    if($slabsFlag == 'N' OR min($minQty) >= 2) {

                                        if((COUNT($minQty) > 0) && (min($minQty) >= 2)){
                                            $maxQty = min($minQty) - 1;
                                        }
                                        $defaultSlab['Article_No'] 		= $arr['no'];
                                        $defaultSlab['Min_Qty'] 		= "1";
                                        $defaultSlab['Max_Qty'] 		= (string)$maxQty;
                                        //$defaultSlab['Supplier_Price'] 	= $row['unit_price'];
                                        $defaultSlab['SK_Offer_Price'] 	= $arr['offer_price'];
                                        $defaultSlab['Offer_From'] 		= "";
                                        $defaultSlab['Offer_To'] 		= "";
                                    }

                                    $arr['slabs_flag']		= $slabsFlag;

                                    if(COUNT($defaultSlab)>0){
                                        //$row['slabs'][0] = $defaultSlab;
                                        array_unshift($slabs,$defaultSlab);
                                    }
                                    if(COUNT($slabs)>0){
                                        /*foreach ($slabs as $slabsArr) {
                                            array_push($row['slabs'], $slabsArr);
                                        }  */
                                        $arr['slabs'] = $slabs;
                                    }


                                    /* For check the slabs data */
                                    //Article More Images - Added by Meenal Barve 16th August 2018
                                    //$article= $row1['no'];
                                    $more_images=array();
                                    $stmt2 = $this->pdo->prepare("SELECT
						Large_Image_Url
						FROM Article_More_Images
						WHERE Article_No = '$ArticleNo' ORDER BY Id ");
                                    $stmt2->execute();
                                    $resultAllArticleImages = array();
                                    $resultAllArticleImages = $stmt2->fetch(PDO::FETCH_ASSOC);

                                    if (!empty($resultAllArticleImages)) {
                                        while ($dataAllArticleImages = $stmt2->fetch(PDO::FETCH_ASSOC))
                                        {
                                            array_push($more_images,$dataAllArticleImages);
                                        }
                                    }

                                    $arr['more_images'] = $more_images;
                                    //End Images

                                    //Article Where Use - Added by Meenal Barve 30th November 2018
                                    //$article= $row1['no'];
                                    $where_use=array();
                                    $queryWhereUse = $this->pdo->prepare("SELECT
						V_Mfg as make,
						V_Mfg_Month_Year as year,
                        V_Model as model
						FROM Article_Where_Use
						WHERE Article_No = '$ArticleNo' ORDER BY V_Mfg,V_Model,V_Mfg_Month_Year");

                                    $queryWhereUse->execute();
                                    $resultAllWhereUse = array();
                                    $resultAllWhereUse = $queryWhereUse->fetch(PDO::FETCH_ASSOC);

                                    if (!empty($resultAllArticleImages)) {
                                        while ($dataAllWhereUse = $queryWhereUse->fetch(PDO::FETCH_ASSOC))
                                        {
                                            array_push($where_use,$dataAllWhereUse);
                                        }
                                    }

                                    // if (mysqli_num_rows($resultAllWhereUse) >0) {
                                    // while ($dataAllWhereUse = mysqli_fetch_assoc($resultAllWhereUse))
                                    // 	{
                                    // 	array_push($where_use,$dataAllWhereUse);
                                    // 	}
                                    // }

                                    $arr['where_use'] = $where_use;
                                    //End Where Use


                                    //Call Procedure to get Article Price -apply all schemes whichever applicable
                                    $currarticle= $ArticleNo;
                                    //Procedure parameters in order - Article no,store no,customer no,qty and casesize
                                    $articleqty = $Quantity;
                                    if ($articleqty =='') {
                                        $articleqty = 1; //by default qty should be 1
                                    }



                                    $queryArticleSchemes = $this->pdo->prepare("SELECT Store_No, Business_No, Cust_No, Cust_Type, Offer_Price, Offer_Rate, Unit_Price, Unit_Rate, Scheme_Price, Scheme_ID, Cust_Margin,Scheme_Name
							FROM Store_Cust_Article_Price SCAP
							WHERE SCAP.Article_No = '$currarticle'
							AND SCAP.Store_No = '$StoreNo'
							AND  SCAP.Cust_No = '$Cust_No'
							ORDER BY SCAP.Cust_No DESC");
                                    $queryArticleSchemes->execute();
                                    $resultArticleSchemes = array();
                                    $resultArticleSchemes = $queryArticleSchemes->fetch(PDO::FETCH_ASSOC);



                                    if (!empty($resultArticleSchemes)) {

                                        $arr['offer_price'] = $resultArticleSchemes['Offer_Price'];
                                        $arr['offer_rate']	= $resultArticleSchemes['Offer_Rate'];
                                        //mmb-android-pricing
                                        $arr['unit_price']  = $resultArticleSchemes['Unit_Price'];
                                        $arr['unit_rate']	= $resultArticleSchemes['Unit_Rate'];
                                        //mmb-android-pricing
                                        $arr['scheme_price']= $resultArticleSchemes['Scheme_Price'];
                                        $arr['scheme_id']   = $resultArticleSchemes['Scheme_ID'];
                                        $arr['scheme_name'] = $resultArticleSchemes['Scheme_Name'];
                                        //$arr['cust_type']   = $resultArticleSchemes['Cust_Type'];      //pricing
                                        $arr['cust_margin'] = $resultArticleSchemes['Cust_Margin'];  //pricing
                                    }

                                    array_push($mystore['items'], $arr);


                                }

                            }

                        }
                    }
                    array_push($cart_array['stores'], $mystore);
                }

            }else{
                $cart_array['stores'] = [];
            }



            if(count($cart_array['stores'])>0){
                $data['cart_data']=$cart_array;
                $msg = "Success";
                $status = true;
            }else{
                $msg = "Fail";
                $status = false;
            }
// echo json_encode($return);
// die;
        }
        catch (PDOException $e) {
            $status = false;
            $data = $e->getMessage();
            return get_response("Something went wrong", $status, $data);
        }
        return get_response($msg, $status, $data);
    }
}
