<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use PDO;
use PDOException;

class FeedbackController extends Controller
{
    public function add_feedback(Request $request){
        $data = $feedbackArr =  array();
        $status = true;

        $post = $request->post();
        Log::info('Request for add_feedback', ['post' => $post]);
        extract($post);
        $Message = addslashes($Message);
        $Creation_Date = date('Y-m-d H:i:s');
        try{
            $arr =[];
            if(isset($Cust_No) && $Cust_No >0 && isset($Store_No) && $Store_No >0)
            {
                Log::debug('In add_feedback in if condition checked isset and not empty cust no and store no', ['Store_No' => $Store_No,'Cust_No' => $Cust_No]);
                if($Type == 'Order')
                {
                    Log::debug('In add_feedback in if condition checked type is order', ['Type' => $Type]);
                    // get feedback of given title and order type
                    $stmt = $this->pdo -> prepare("select Title , Type from Customer_Feedback where Title = '$Title' and Type = 'Order' ");

                    $stmt ->execute();
                    $feedbackArr = $stmt->fetchAll(PDO::FETCH_ASSOC);
                    Log::debug('In add_feedback execution of query to get feedback of given title and order type', ['Type' => $Type,'Title'=>$Title,'query'=>$stmt]);
                }
                // if feedbackArr not get feedback then given tile get inserted
                if(empty($feedbackArr))
                {
                    Log::debug('In add_feedback in if condition to check feedbackArr array', ['feedbackArr' => $feedbackArr]);
                    $stmt = $this->pdo->prepare("INSERT INTO Customer_Feedback(
      				Title,
      				Type,
      				Message,
      				Cust_No,
      				Store_No,
      				FSO_No,
      				Cust_Type,
      				Creation_Date,
      				Created_By,
      				Changed_Date,
      				Changed_By
      			    ) values ('$Title' , '$Type' , '$Message' , '$Cust_No' , '$Store_No' ,
                    '$FSO_No' , '$Cust_Type' , '$Creation_Date' , '$Cust_No' , '$Creation_Date' , '$Cust_No')");
                }
                // if feedbackArr get feedback then given tile get updated
                else
                {
                    $stmt = $this->pdo->prepare("UPDATE Customer_Feedback SET
                          Title = '$Title',
                          Type = '$Type',
                          Message = '$Message',
                          Cust_No = '$Cust_No',
                          Store_No = '$Store_No',
                          FSO_No = '$fSO_No',
                          Cust_Type = '$Cust_Type',
                          Changed_Date = '$Creation_Date',
                          Changed_By = '$Cust_No' WHERE Title = '$Title' and Type = '$Type'");
                }
                Log::debug('In add_feedback to insert/update feedback following query is executed', ['stmt' => $stmt]);
                $stmt -> execute();
                if($stmt)
                {
                    $msg = 'Feedback Added Successfully.';
                }
                else
                {
                    $msg = 'Unable To Add Feedback.';
                    $status = false;
                }
            }
            else
            {
                $msg = 'Invalid Data';
                $status = false;
            }

        }
        catch (PDOException $e)
        {
            $msg = "Something went wrong";
            $status = false;
            $data = $e->getMessage();
            Log::debug('Response for add_feedback in catch', ['data' => $data,'status'=>false,'msg'=>$msg]);
            // return getResponse($response, , $status, $msg);
        }
        Log::info('Response for add_feedback', ['data' => $data,'status'=>false,'msg'=>$msg]);
        return get_response($msg, $status, $data);
    }
}
