<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;
use PDOException;

class NotificationController extends Controller
{
    public function notification_history(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);

        try {
            if (!empty($Cust_No) && !empty($Store_No)) {
                $stmt = $this->pdo->prepare("(select Cust_No, Store_No, COALESCE(Order_No, '') as Order_No , COALESCE(FSO_No,'') as FSO_No, Notif_Title, Notif_Message, DATE_FORMAT(Sent_Date, '%d-%b-%y') Sent_Date, DATE_FORMAT(Sent_Date, '%Y-%m-%d') Order_Date, Status, Status_Msg from BBC_Notification_History where Store_No = '$Store_No' and Cust_No='$Cust_No')
                UNION
                 (select Cust_No, Store_No, COALESCE(Order_No, '') as Order_No , COALESCE(FSO_No,'') as FSO_No, Notif_Title, Notif_Message, DATE_FORMAT(Sent_Date, '%d-%b-%y') Sent_Date, DATE_FORMAT(Sent_Date, '%Y-%m-%d') Order_Date, Status, Status_Msg from BBC_Notification_History where Store_No = '$Store_No' and Cust_No='0') Order By Order_Date DESC");

                $stmt->execute();
                $arr = $stmt->fetchAll(PDO::FETCH_ASSOC);
                //$stmt->debugDumpParams();
                if (!empty($arr)) {

                    $data = $arr;
                    $msg = 'Success';
                } else {
                    $msg = 'Data is not available';
                    $status = false;
                }
            }
        } catch (PDOException $e) {
            $status = false;
            $data = $e->getMessage();
            $msg = "Something went wrong";
        }

        return get_response($msg, $status, $data);
    }
}
