<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;
use PDOException;

class OfflineController extends Controller
{
    public function offline_error(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();

        try {

            $created_by = $post['Created_By'] ?? 1001;
            $changed_by = $post['Changed_By'] ?? 1001;
            $payload =  json_encode($post);

            $stmt = $this->pdo->prepare("
            INSERT INTO Offline_Errors (
            Payload, Status, Created_By, Changed_By ) Values ('".$payload."', 'Pending', ".$created_by.", ".$changed_by." )");
            $stmt -> execute();
            //$stmt->debugDumpParams();
            $msg = 'Success';
            $this->emailOfflineSyncBug($payload);

        } catch (PDOException $e) {
            $msg = "Something went wrong";
            $status = false;
            $data = $e->getMessage();
        }

        return get_response($msg, $status, $data);
    }

    private function emailOfflineSyncBug($payload){
        // Replace recipient@example.com with a "To" address. If your account
        // is still in the sandbox, this address must be verified.
        $recepientInfo = ['daya4608@gmail.com'];

        // The plain-text body of the email
        $bodyText =  "Alert";

        $subject =  "Alert!!! ".MY_WEBSITE." OFFLINE BUG";

        // The HTML-formatted body of the email
        $bodyHtml = '
        <pre>Dear Saralideas Team,

        We have received '.MY_WEBSITE.' offline sync issue

        ';
        $bodyHtml .= $payload;

        $mail = new PHPMailer(true);

        try {
            // Specify the SMTP settings.
            $mail->isSMTP();
            $mail->setFrom("snapkirna.co.in@gmail.com", 'SARALIDEAS');
            $mail->Username   = 'snapkirna.co.in@gmail.com';
            $mail->Password   = '2021@saral';

            $mail->Host       = 'ssl://smtp.googlemail.com';
            $mail->Port       = 465;
            $mail->SMTPAuth   = true;
            $mail->SMTPSecure = 'tls';
            //$mail->addCustomHeader('X-SES-CONFIGURATION-SET', $configurationSet);

            // Specify the message recipients.
            if(!empty($recepientInfo)){
                foreach ($recepientInfo as $recepient) {
                    $mail->addAddress($recepient);
                }
            }

            // You can also add CC, BCC, and additional To recipients here.
            //$mail->addCC("ccaddress@ccdomain.com", "Some CC Name");
            //$mail->addBCC("bccaddress@ccdomain.com", "Some BCC Name");


            // Specify the content of the message.
            $mail->isHTML(true);
            $mail->Subject    = $subject;
            $mail->Body       = $bodyHtml;
            $mail->AltBody    = $bodyText;
            //$mail->SMTPDebug = 2;//debug email
            $re = $mail->Send();
            $res = "Email sent!";
        } catch (Exception $e) {
            //If not working On in Google and then Manage your Google Account->Security->Under "Signing in to Google," tap 2-Step Verification: Access for less secure apps
            $res = "Email not sent. {$mail->ErrorInfo}"; //Catch errors from Amazon SES.
        }
        return $res;
    }
}
