<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use PDO;
use PDOException;

class PromoCodeController extends Controller
{
    public function applypromocode(Request $request){
        $data = array();
        $status = true;
        $post = $request->post();
        extract($post);

        try
        {
            // check given promo is available or not
            $queryPromoHdr = $this->pdo->prepare("select * from Promo_Hdr inner join Promo_Order_Level on
		Promo_Hdr.Promo_Code = Promo_Order_Level.Promo_Code
		where (Promo_Hdr.Store_No != 0 OR Promo_Hdr.Store_No != '')  AND Promo_Hdr.Store_No = '$store_no' AND Promo_Hdr.Promo_Code = '$promo_code' AND Promo_Hdr.Status = 'A'");
            $queryPromoHdr->execute();

            $result = $queryPromoHdr->fetch(PDO::FETCH_ASSOC);

            // if promo is available
            if(!empty($result))
            {
                $CurrentDate      = strtotime(date('Y-m-d'));
                $ValidDateFrom    = strtotime($result['Valid_From']);
                $ValidDateTo      = strtotime($result['Valid_To']);
                $AbsoluteDiscount = $result['Absolute_Disc'];
                $PercentDiscount  = $result['Percent_Disc'];
                $MaxDiscAmount    = $result['Max_Disc_Amt'];
                $OfferDescription = $result['Offer_Desc'];
                $CoorporateOffer  = $result['Coorporate_Offer'];
                $PromoCode 		  = $result['Promo_Code'];
                $RedeemTolerance  = $result['Redeem_Tolerance'];
                $TotalRedeemption = $result['Total_Redeemption'];
                $Amount;
                $FinalAmount;
                $offer_desc;

                $order_times = $result['NO_Of_Times_Per_User'];
                $Cust_No = $customer_no;

                $query1 = $this->pdo->prepare("select * from Customer_Promo_Applied where `Times` >= '$order_times' AND  Promo_Code='$promo_code' AND Cust_No='$Cust_No' AND `Store_No` = '$store_no'");

                $query1->execute();
                $result1 = $query1->fetch(PDO::FETCH_ASSOC);

                if(empty($result1))
                {

                    if( !($ValidDateFrom <= $CurrentDate && $ValidDateTo >= $CurrentDate && $result['Redeem_Tolerance'] >= $result['Total_Redeemption']))
                    {
                        $msg = "Sorry! Promo Code you entered has expired!";
                        $data['offer_type'] = intval($CoorporateOffer);
                        $data['discount_applied'] = "0.00";
                        $status = false;
                        $offer_desc = "";
                    }
                    elseif(!($result['Order_Valume_From'] <= $total_amount))
                    {
                        $msg = "Sorry! This is not valid promo code for your order!";
                        $data['offer_type']=intval($CoorporateOffer);
                        $data['discount_applied']="0.00";
                        $status = false;
                        $offer_desc = "";

                    }else{

                        $success_message;

                        if($AbsoluteDiscount != '' && $AbsoluteDiscount != '0' && $AbsoluteDiscount != '0.00')
                        {
                            $discount_main=$AbsoluteDiscount;
                            $offer_desc = "";

                        }else if($AbsoluteDiscount == '' || $AbsoluteDiscount == '0' || $AbsoluteDiscount == '0.00')
                        {
                            $Discount =  ($total_amount * $PercentDiscount) / 100;
                            $discount_main=$Discount;

                            if($Discount > $MaxDiscAmount)
                            {
                                $discount_main = $MaxDiscAmount;
                            }else{
                                $discount_main = $discount_main;
                            }
                            $offer_desc = $OfferDescription;

                        }

                        $msg = 'Congratulations! Promo code applied successfully';
                        $actual_amount = number_format((float)$discount_main, 2, '.', '');
                        $data['offer_desc']=$offer_desc;
                        $data['promo_code']=$PromoCode;
                        $data['offer_type']=intval($CoorporateOffer);
                        $data['discount_applied']="".$actual_amount."";
                        $status = true;
                    }
                }else{
                    $msg = 'You have reached maximum redemption limit for this Promo Code';
                    $data['offer_type']=intval($CoorporateOffer);
                    $data['discount_applied']="0.00";
                    $status = false;
                }

            } else {

                $query = $this->pdo->prepare("select * from Promo_Hdr inner join Promo_Order_Level on
				Promo_Hdr.Promo_Code = Promo_Order_Level.Promo_Code
				where Promo_Hdr.Promo_Code = '$promo_code' AND Promo_Hdr.Status = 'A' AND Promo_Hdr.`Coorporate_Offer` IN(1,3)");
                $query->execute();
                $result = $query->fetch(PDO::FETCH_ASSOC);

                if(!empty($result))
                {
                    $CurrentDate      = strtotime(date('Y-m-d'));
                    $ValidDateFrom    = strtotime($result['Valid_From']);
                    $ValidDateTo      = strtotime($result['Valid_To']);
                    $AbsoluteDiscount = $result['Absolute_Disc'];
                    $PercentDiscount  = $result['Percent_Disc'];
                    $MaxDiscAmount    = $result['Max_Disc_Amt'];
                    $OfferDescription = $result['Offer_Desc'];
                    $PromoCode 		  = $result['Promo_Code'];
                    $CoorporateOffer  = $result['Coorporate_Offer'];
                    $RedeemTolerance  = $result['Redeem_Tolerance'];
                    $TotalRedeemption = $result['Total_Redeemption'];
                    $Amount;
                    $FinalAmount;
                    $offer_desc;



                    $order_times = $result['NO_Of_Times_Per_User'];
                    $Cust_No = $customer_no;
                    $query1 = $this->pdo->prepare("select * from Customer_Promo_Applied where `Times` >= '$order_times' AND  Promo_Code='$promo_code' AND Cust_No='$Cust_No' AND `Store_No` = '0'");
                    $query1->execute();
                    $result1 = $query1->fetch(PDO::FETCH_ASSOC);

                    if(empty($result1))
                    {

                        if( !($ValidDateFrom <= $CurrentDate && $ValidDateTo >= $CurrentDate && $result['Redeem_Tolerance'] >= $result['Total_Redeemption']))
                        {
                            $msg = "Sorry! Promo Code you entered has expired!";
                            $data['offer_type'] = intval($CoorporateOffer);
                            $data['discount_applied'] = "0.00";
                            $status = false;

                            $offer_desc = "";
                        }
                        elseif(!($result['Order_Valume_From'] <= $total_amount))
                        {
                            $msg = "Sorry! This is not valid promo code for your order!";
                            $data['offer_type'] = intval($CoorporateOffer);
                            $data['discount_applied'] = "0.00";
                            $status = false;

                            $offer_desc = "";

                        }else{

                            $success_message;

                            if($AbsoluteDiscount != '' && $AbsoluteDiscount != '0' && $AbsoluteDiscount != '0.00')
                            {
                                $discount_main=$AbsoluteDiscount;
                                $offer_desc = "";

                            }else if($AbsoluteDiscount == '' || $AbsoluteDiscount == '0' || $AbsoluteDiscount == '0.00')
                            {
                                $Discount =  ($total_amount * $PercentDiscount) / 100;
                                $discount_main=$Discount;

                                if($Discount > $MaxDiscAmount)
                                {
                                    $discount_main = $MaxDiscAmount;
                                }else{
                                    $discount_main = $discount_main;
                                }
                                $offer_desc = $OfferDescription;

                            }

                            $msg = 'Congratulations! Promo code applied successfully';
                            $actual_amount = number_format((float)$discount_main, 2, '.', '');
                            $data['offer_desc'] = $offer_desc;
                            $data['promo_code'] = $PromoCode;
                            $data['offer_type'] = intval($CoorporateOffer);
                            $data['discount_applied'] = "".$actual_amount."";
                            $status = true;
                        }

                    }else{
                        $msg = 'You have reached maximum redemption limit for this Promo Code';
                        $data['offer_type'] = intval($CoorporateOffer);
                        $data['discount_applied'] = "0.00";
                        $status = false;
                    }

                }else{
                    $msg = "Invalid Promo Code";
                    $data['discount_applied'] = "0.00";
                    $status = false;
                }

            }
        }
        catch (PDOException $e)
        {
            $msg = "Something went wrong";
            $status = false;
            $data = $e->getMessage();
        }

        return get_response($msg, $status, $data);
    }
}
